; ================================================================================ 
;   darius/src/boss.asm                                                            
;                                                                                  
;   Copyright (C) 2017 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.CODE

; ---------------------------------------------------------------- 
;   {X쐬                                                       
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A, X, Y                                                 
; ---------------------------------------------------------------- 
CRE_BOSS:
	ADD_TASK_QUE	#TASK_BOSS

	TSK_CHG	TASK_BOSS, .TASK_WAIT
	MOV	TCB_XPOS_H+TASK_BOSS, BOSS0_INI_XPOS+1
	MOV	TCB_XPOS_L+TASK_BOSS, BOSS0_INI_XPOS+0
	MOV	TCB_YPOS_H+TASK_BOSS, BOSS0_INI_YPOS+1
	MOV	TCB_YPOS_L+TASK_BOSS, BOSS0_INI_YPOS+0
	MOV	TCB_XPOS_F+TASK_BOSS, #0
	STA	TCB_YPOS_F+TASK_BOSS
	MOV	TCB_ANGLE+TASK_BOSS,  BOSS0_INI_ANGLE
	MOV	TCB_SPEED+TASK_BOSS,  #3
	MOV	TCB_COUNT0+TASK_BOSS, #HIGH(60*4)
	MOV	TCB_COUNT1+TASK_BOSS, #LOW(60*4)

	JMP	(BOSS0_INI_PROC)


; ------------------------------------------------ 
;   o҂^XN                             
; ------------------------------------------------ 
.TASK_WAIT:
	ADD_TASK_QUE	#TASK_BOSS

	DEC	TCB_COUNT1+TASK_BOSS
	BNE	@F
	LDA	TCB_COUNT0+TASK_BOSS
	BEQ	.TASK_WAIT_000
	DEC	TCB_COUNT0+TASK_BOSS
@@:
	TSK_RET


.TASK_WAIT_000:
	TSK_CHG	TASK_BOSS, .TASK_EMERGE

	JSR	SET_BOSS_POS
	JSR	SET_BG_BOSS
	JSR	.CRE_FADEIN
	TSK_RET


; ------------------------------------------------ 
;   o^XN                                 
; ------------------------------------------------ 
.TASK_EMERGE:
	ADD_TASK_QUE

	JSR	MOVE_ANGLE
	JSR	SET_BOSS_POS

	LDA	BOSS0_INI_STOP_YPOS
	CMP	TCB_YPOS_L+TASK_BOSS
	BCC	@F

	TSK_CHG	.TASK_EMERGE_100
	MOV	TCB_COUNT0+TASK_BOSS, #40
@@:
	TSK_RET


.TASK_EMERGE_100:
	ADD_TASK_QUE

	DEC	TCB_COUNT0+TASK_BOSS
	BNE	@F

	JSR	.INI_START
@@:
	TSK_RET


.INI_START:
	JMP	(BOSS0_INI_START_PROC)


; ---------------------------------------------------------------- 
;   tF[hC^XN쐬                                         
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A, X, Y                                                 
; ---------------------------------------------------------------- 
.CRE_FADEIN:
	LDY	#0
	JMP	@F

; ---------------------------------------------------------------- 
;   tF[hAEg^XN쐬                                       
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A, X, Y                                                 
; ---------------------------------------------------------------- 
.CRE_FADEOUT:
	LDY	#64
@@:
	TSK_CRE	X, .TASK_FADE
	MOV	TCB_COUNT0,X, BOSS0_INI_FADEIN_WAIT+1		; Jn
	MOV	TCB_COUNT1,X, BOSS0_INI_FADEIN_WAIT+0		;
	TYA
	STA	TCB_COUNT2,X					; Fʒu

; ---------------------------------------------------------------- 
;   tF[hFݒ                                               
;                                                                  
;   IN   : X = ^XNԍ                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, X, Y                                                 
; ---------------------------------------------------------------- 
.SET_FADE_COLOR:
	LDY	<VRAM_DATA_COUNT

	LDA	TCB_COUNT2,X
	TAX
	MOV	<TEMP+0, BOSS0_FADEIN_BOSS2,X
	MOV	<TEMP+1, BOSS0_FADEIN_BOSS3,X

	MOV	VRAM_DATA_BUFF+VRAM_H,Y,     #HIGH($3F01)
	MOV	VRAM_DATA_BUFF+VRAM_L,Y,     #LOW($3F01)
	MOV	VRAM_DATA_BUFF+VRAM_COUNT,Y, #(3+4)
	LDX	<TEMP+0
	MOV	VRAM_DATA_BUFF+VRAM_DATA+0,Y, COL_DATA1,X
	MOV	VRAM_DATA_BUFF+VRAM_DATA+1,Y, COL_DATA2,X
	MOV	VRAM_DATA_BUFF+VRAM_DATA+2,Y, COL_DATA3,X
	LDX	<TEMP+1
	MOV	VRAM_DATA_BUFF+VRAM_DATA+3,Y, COL_DATA1,X
	MOV	VRAM_DATA_BUFF+VRAM_DATA+4,Y, COL_DATA2,X
	MOV	VRAM_DATA_BUFF+VRAM_DATA+5,Y, COL_DATA3,X
	MOV	VRAM_DATA_BUFF+VRAM_DATA+6,Y, COL_DATA3,X

	TYA
	ADD	#10
	STA	<VRAM_DATA_COUNT
	RTS


; ------------------------------------------------ 
;   tF[h^XN                             
; ------------------------------------------------ 
.TASK_FADE:
	ADD_TASK_QUE

	DEC	TCB_COUNT1,X
	BNE	@F
	DEC	TCB_COUNT0,X
	BPL	@F

	MOV	TCB_COUNT0,X, BOSS0_INI_FADEIN_SPEED

	TSK_CHG	.TASK_FADE_000
@@:
	TSK_RET


.TASK_FADE_000:
	DEC	TCB_COUNT0,X
	BNE	@F

	INC	TCB_COUNT2,X
	LDA	TCB_COUNT2,X
	AND	#3
	BEQ	.TASK_FADE_0F0

	MOV	TCB_COUNT0,X, BOSS0_INI_FADEIN_SPEED

	JSR	.SET_FADE_COLOR
@@:
	ADD_TASK_QUE	<TASK_RUN

.TASK_FADE_0F0:
	TSK_RET


; ---------------------------------------------------------------- 
;   쐬                                                       
;                                                                  
;   IN   : X = e^XNԍ                                        
;   OUT  : Ȃ                                                    
;   BREAK: A, X, Y, TEMP+0, TEMP+1                                 
; ---------------------------------------------------------------- 
CRE_EXPLOSION:
	; 쐬ς݂Ȃ疳
	LDY	TCB_COUNT3,X
	BNE	.CRE_EXPLOSION_0F0

	; ʊOȂI
	LDA	TCB_XPOS_L,X
	ADD	TCB_XPOS_L+TASK_BOSS
	BCS	.CRE_EXPLOSION_0F0
	STA	<TEMP+0

	LDA	TCB_YPOS_L,X
	ADD	TCB_YPOS_L+TASK_BOSS
	BCS	.CRE_EXPLOSION_0F0
	STA	<TEMP+1

	TSK_CRE	Y, .TASK_EXPLOSION
	MOV	TCB_XPOS_L,Y, <TEMP+0
	MOV	TCB_YPOS_L,Y, <TEMP+1
	MOV	TCB_XPOS_H,Y, #0
	STA	TCB_YPOS_H,Y

	; ^XNԍۑ
	TXA
	STA	TCB_COUNT3,Y
	TYA
	STA	TCB_COUNT3,X

.CRE_EXPLOSION_0F0:
	RTS


; ------------------------------------------------ 
;   ^XN                                 
; ------------------------------------------------ 
.TASK_EXPLOSION:
	TSK_CHG	.TASK_EXPLOSION_100

	ADD_TASK_QUE

	LDA	#COMM_TBL_EXPLOSION_L
	JSR	SET_ACT
	JSR	SET_SPR_BUFF
	TSK_RET


.TASK_EXPLOSION_100:
	JSR	ACT_TASK
	BCS	@F

	ADD_TASK_QUE

	JSR	SET_SPR_BUFF
	TSK_RET

@@:
	LDY	TCB_COUNT3,X
	MOV	TCB_COUNT3,Y, #0
	PUT_TASK_NO
	TSK_RET
