; ================================================================================ 
;   darius/src/boss0.asm                                                           
;                                                                                  
;   Copyright (C) 2017 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.CODE

; ---------------------------------------------------------------- 
;                                                            
; ---------------------------------------------------------------- 
BOSS0_INI:
	ADD_TASK_QUE	#TASK_BOSS_OVERLAY0
	TSK_CHG	TASK_BOSS_OVERLAY0, .TASK_OVERLAY0

	MOV	<SPR_BANK0, #BANK_BOSS0_SPR0
	MOV	<SPR_BANK1, #BANK_BOSS0_SPR1
	RTS


; ---------------------------------------------------------------- 
;   Jn                                                           
; ---------------------------------------------------------------- 
BOSS0_START:
	; {
	TSK_CHG	TASK_BOSS, .TASK_BODY
	MOV	TCB_ANGLE   +TASK_BOSS, #231
	MOV	TCB_SPEED   +TASK_BOSS, #2
	MOV	TCB_COUNT2  +TASK_BOSS, #BOSS0_PAT_BASE0
	MOV	TCB_COUNT3  +TASK_BOSS, #0
	MOV	TCB_HIT     +TASK_BOSS, #BOSS0_HIT_BODY
	MOV	TCB_HIT_TYPE+TASK_BOSS, #BOSS0_HIT_BODY
	JSR	.SET_CAUDALFIN

	; 
	TSK_CHG	TASK_BOSS_OVERLAY0, .TASK_MOUTH
	MOV	TCB_HIT     +TASK_BOSS_OVERLAY0, #0
	MOV	TCB_HIT_TYPE+TASK_BOSS_OVERLAY0, #BOSS0_HIT_MOUTH
	MOV	TCB_COUNT0  +TASK_BOSS_OVERLAY0, #HIGH(20)
	MOV	TCB_COUNT1  +TASK_BOSS_OVERLAY0, #LOW(20)
	MOV	TCB_COUNT2  +TASK_BOSS_OVERLAY0, #60

	; wr
	ADD_TASK_QUE	#TASK_BOSS_OVERLAY1
	TSK_CHG	TASK_BOSS_OVERLAY1, .TASK_DORSALFIN
	MOV	TCB_XPOS_L  +TASK_BOSS_OVERLAY1, #118
	MOV	TCB_YPOS_L  +TASK_BOSS_OVERLAY1, #8
	MOV	TCB_HIT     +TASK_BOSS_OVERLAY1, #0
	MOV	TCB_HIT_TYPE+TASK_BOSS_OVERLAY1, #BOSS0_HIT_DORSALFIN
	MOV	TCB_COUNT0  +TASK_BOSS_OVERLAY1, #HIGH(40)
	MOV	TCB_COUNT1  +TASK_BOSS_OVERLAY1, #LOW(40)
	MOV	TCB_COUNT3  +TASK_BOSS_OVERLAY1, #0
	STA	TCB_XPOS_H  +TASK_BOSS_OVERLAY1
	STA	TCB_YPOS_H  +TASK_BOSS_OVERLAY1

	; \r
	ADD_TASK_QUE	#TASK_BOSS_OVERLAY2
	TSK_CHG	TASK_BOSS_OVERLAY2, .TASK_ANALFIN
	MOV	TCB_XPOS_L  +TASK_BOSS_OVERLAY2, #148
	MOV	TCB_YPOS_L  +TASK_BOSS_OVERLAY2, #80
	MOV	TCB_HIT     +TASK_BOSS_OVERLAY2, #0
	MOV	TCB_HIT_TYPE+TASK_BOSS_OVERLAY2, #BOSS0_HIT_ANALFIN
	MOV	TCB_COUNT0  +TASK_BOSS_OVERLAY2, #HIGH(20)
	MOV	TCB_COUNT1  +TASK_BOSS_OVERLAY2, #LOW(20)
	MOV	TCB_COUNT3  +TASK_BOSS_OVERLAY2, #0
	STA	TCB_XPOS_H  +TASK_BOSS_OVERLAY2
	STA	TCB_YPOS_H  +TASK_BOSS_OVERLAY2
	RTS


; ---------------------------------------------------------------- 
;   oNݒ肠ANV                                       
; ---------------------------------------------------------------- 
.ACT_BANK:
	DEC	TCB_PAT_COUNT,X
	BNE	.ACT_BANK_080

	INC	TCB_ACT,X
	LDY	TCB_ACT,X

	LDA	BOSS0_TBL_COUNT,Y
	BEQ	.ACT_BANK_0F0

	STA	TCB_PAT_COUNT,X

	MOV	TCB_PAT,X, BOSS0_TBL_PAT,Y

	MOV	<BOSS_BANK3, BOSS0_TBL_PARAM,Y

.ACT_BANK_080:
	CLC
	RTS

.ACT_BANK_0F0:
	SEC
	RTS


; ---------------------------------------------------------------- 
;   oNݒȂANV                                       
; ---------------------------------------------------------------- 
.ACT_NOBANK:
	DEC	TCB_PAT_COUNT,X
	BNE	.ACT_NOBANK_080

	INC	TCB_ACT,X
	LDY	TCB_ACT,X

	LDA	BOSS0_TBL_COUNT,Y
	BEQ	.ACT_NOBANK_0F0

	STA	TCB_PAT_COUNT,X

	MOV	TCB_PAT,X, BOSS0_TBL_PAT,Y

.ACT_NOBANK_080:
	CLC
	RTS

.ACT_NOBANK_0F0:
	SEC
	RTS


; ---------------------------------------------------------------- 
;   rݒ                                                     
; ---------------------------------------------------------------- 
.SET_CAUDALFIN:
	MOV	TCB_ACT      +TASK_BOSS, #BOSS0_TBL_CAUDALFIN
	MOV	TCB_PAT      +TASK_BOSS, BOSS0_TBL_PAT  +BOSS0_TBL_CAUDALFIN
	MOV	TCB_PAT_COUNT+TASK_BOSS, BOSS0_TBL_COUNT+BOSS0_TBL_CAUDALFIN
	MOV	<BOSS_BANK2,             BOSS0_TBL_PARAM+BOSS0_TBL_CAUDALFIN
	RTS


; ---------------------------------------------------------------- 
;   rANV                                               
; ---------------------------------------------------------------- 
.ACT_CAUDALFIN:
	DEC	TCB_PAT_COUNT+TASK_BOSS
	BNE	@F

	; TCB_ACT[X]++
	INC	TCB_ACT+TASK_BOSS
	LDY	TCB_ACT+TASK_BOSS

	; if( BOSS0_TBL_COUNT[Y] ) goto .SET_CAUDALFIN
	LDA	BOSS0_TBL_COUNT,Y
	BEQ	.SET_CAUDALFIN

	STA	TCB_PAT_COUNT+TASK_BOSS

	MOV	TCB_PAT+TASK_BOSS, BOSS0_TBL_PAT,Y

	MOV	<BOSS_BANK2, BOSS0_TBL_PARAM,Y
@@:
	RTS


; ------------------------------------------------ 
;   d˃^XN                                 
; ------------------------------------------------ 
.TASK_OVERLAY0:
	ADD_TASK_QUE

	LDY	TCB_COUNT2+TASK_BOSS
	JSR	SET_BOSS_SPR_BUFF

	LDY	#BOSS0_PAT_MOUTH0
	JSR	SET_BOSS_SPR_BUFF

	LDY	TCB_PAT+TASK_BOSS
	JSR	SET_BOSS_SPR_BUFF
	TSK_RET


; ------------------------------------------------ 
;   {̃^XN                                 
; ------------------------------------------------ 
.TASK_BODY:
	ADD_TASK_QUE

	JSR	MOVE_ANGLE
	JSR	SET_BOSS_POS

	; 
	LDA	TCB_XPOS_L+TASK_BOSS
	CMP	#56
	BCS	@F

	LDA	TCB_ANGLE+TASK_BOSS
	EOR	#$7F
	STA	TCB_ANGLE+TASK_BOSS
@@:
	; E
	LDA	TCB_XPOS_L+TASK_BOSS
	CMP	#224
	BCC	@F

	LDA	TCB_ANGLE+TASK_BOSS
	EOR	#$7F
	STA	TCB_ANGLE+TASK_BOSS
@@:
	; 
	LDA	TCB_YPOS_L+TASK_BOSS
	CMP	#8
	BCS	@F

	LDA	#0
	SUB	TCB_ANGLE+TASK_BOSS
	STA	TCB_ANGLE+TASK_BOSS
@@:
	; 
	LDA	TCB_YPOS_L+TASK_BOSS
	CMP	#120
	BCC	@F

	LDA	#0
	SUB	TCB_ANGLE+TASK_BOSS
	STA	TCB_ANGLE+TASK_BOSS
@@:
	JSR	.ACT_CAUDALFIN

	LDY	TCB_COUNT2+TASK_BOSS
	JSR	SET_BOSS_SPR_BUFF

	LDY	TCB_PAT+TASK_BOSS
	JSR	SET_BOSS_SPR_BUFF
	JSR	ADD_BOSS_HIT_QUE
	TSK_RET


; ------------------------------------------------ 
;   ^XN                                   
; ------------------------------------------------ 
.TASK_MOUTH:
	ADD_TASK_QUE

	DEC	TCB_COUNT2+TASK_BOSS_OVERLAY0
	BNE	@F

	TSK_CHG	TASK_BOSS_OVERLAY0, .TASK_MOUTH_100
	MOV	TCB_ACT      +TASK_BOSS_OVERLAY0, #BOSS0_TBL_OPENMOUTH
	MOV	TCB_PAT_COUNT+TASK_BOSS_OVERLAY0, BOSS0_TBL_COUNT+BOSS0_TBL_OPENMOUTH
	MOV	TCB_PAT      +TASK_BOSS_OVERLAY0, BOSS0_TBL_PAT  +BOSS0_TBL_OPENMOUTH
	MOV	<BOSS_BANK3,                      BOSS0_TBL_PARAM+BOSS0_TBL_OPENMOUTH
@@:
	LDY	#BOSS0_PAT_MOUTH0
	JSR	SET_BOSS_SPR_BUFF
	JSR	ADD_BOSS_HIT_QUE
	TSK_RET


.TASK_MOUTH_100:
	ADD_TASK_QUE

	JSR	.ACT_BANK
	BCC	@F

	TSK_CHG	TASK_BOSS_OVERLAY0, .TASK_MOUTH_200
	MOV	TCB_ACT      +TASK_BOSS_OVERLAY0, #BOSS0_TBL_PREATTACK
	MOV	TCB_PAT_COUNT+TASK_BOSS_OVERLAY0, BOSS0_TBL_COUNT+BOSS0_TBL_PREATTACK
	MOV	TCB_PAT      +TASK_BOSS_OVERLAY0, BOSS0_TBL_PAT  +BOSS0_TBL_PREATTACK
@@:
	LDY	TCB_PAT+TASK_BOSS_OVERLAY0
	JSR	SET_BOSS_SPR_BUFF
	JSR	ADD_BOSS_HIT_QUE
	TSK_RET


.TASK_MOUTH_200:
	ADD_TASK_QUE

	JSR	.ACT_NOBANK
	BCC	@F

	TSK_CHG	TASK_BOSS_OVERLAY0, .TASK_MOUTH_300
	MOV	TCB_COUNT2+TASK_BOSS_OVERLAY0, #3

.TASK_MOUTH_240:
	MOV	TCB_ACT      +TASK_BOSS_OVERLAY0, #BOSS0_TBL_FIRE
	MOV	TCB_PAT_COUNT+TASK_BOSS_OVERLAY0, BOSS0_TBL_COUNT+BOSS0_TBL_FIRE
	MOV	TCB_PAT      +TASK_BOSS_OVERLAY0, BOSS0_TBL_PAT  +BOSS0_TBL_FIRE

	; e쐬
	MOV	<TEMP+1, #(3*4)
	MOV	<TEMP+2, #0
	LDA	TCB_XPOS_L+TASK_BOSS
	ADD	#16
	STA	<TEMP+3
	MOV	<TEMP+4, #0
	LDA	TCB_YPOS_L+TASK_BOSS
	ADD	#66
	STA	<TEMP+5

	MOV	<TEMP+0, #(128+ 0)
	JSR	CRE_BULLET0

	MOV	<TEMP+0, #(128- 8)
	JSR	CRE_BULLET0

	MOV	<TEMP+0, #(128+ 8)
	JSR	CRE_BULLET0

	MOV	<TEMP+0, #(128-16)
	JSR	CRE_BULLET0

	MOV	<TEMP+0, #(128+16)
	JSR	CRE_BULLET0
@@:
	LDY	TCB_PAT+TASK_BOSS_OVERLAY0
	JSR	SET_BOSS_SPR_BUFF
	JSR	ADD_BOSS_HIT_QUE
	TSK_RET


.TASK_MOUTH_300:
	ADD_TASK_QUE

	JSR	.ACT_NOBANK
	BCC	@F

	DEC	TCB_COUNT2+TASK_BOSS_OVERLAY0
	BNE	.TASK_MOUTH_240

	TSK_CHG	TASK_BOSS_OVERLAY0, .TASK_MOUTH_400
	MOV	TCB_COUNT2+TASK_BOSS_OVERLAY0, #60

	; UI
	MOV	TCB_ACT      +TASK_BOSS_OVERLAY0, #BOSS0_TBL_POSTATTACK
	MOV	TCB_PAT_COUNT+TASK_BOSS_OVERLAY0, BOSS0_TBL_COUNT+BOSS0_TBL_POSTATTACK
	MOV	TCB_PAT      +TASK_BOSS_OVERLAY0, BOSS0_TBL_PAT  +BOSS0_TBL_POSTATTACK
@@:
	LDY	TCB_PAT+TASK_BOSS_OVERLAY0
	JSR	SET_BOSS_SPR_BUFF
	JSR	ADD_BOSS_HIT_QUE
	TSK_RET


.TASK_MOUTH_400:
	ADD_TASK_QUE

	JSR	.ACT_NOBANK
	BCC	@F

	TSK_CHG	TASK_BOSS_OVERLAY0, .TASK_MOUTH_500
	MOV	TCB_COUNT2+TASK_BOSS_OVERLAY0, #60

	; 
	MOV	TCB_ACT      +TASK_BOSS_OVERLAY0, #BOSS0_TBL_CLOSEMOUTH
	MOV	TCB_PAT_COUNT+TASK_BOSS_OVERLAY0, BOSS0_TBL_COUNT+BOSS0_TBL_CLOSEMOUTH
	MOV	TCB_PAT      +TASK_BOSS_OVERLAY0, BOSS0_TBL_PAT  +BOSS0_TBL_CLOSEMOUTH
@@:
	LDY	TCB_PAT+TASK_BOSS_OVERLAY0
	JSR	SET_BOSS_SPR_BUFF
	JSR	ADD_BOSS_HIT_QUE
	TSK_RET


	; -------------------------------- 
	;                          
	; -------------------------------- 
.TASK_MOUTH_500:
	ADD_TASK_QUE

	JSR	.ACT_BANK
	BCC	@F

	TSK_CHG	TASK_BOSS_OVERLAY0, .TASK_MOUTH
	MOV	TCB_COUNT0+TASK_BOSS_OVERLAY0, #60
@@:
	LDY	TCB_PAT+TASK_BOSS_OVERLAY0
	JSR	SET_BOSS_SPR_BUFF
	JSR	ADD_BOSS_HIT_QUE
	TSK_RET


; ------------------------------------------------ 
;   wr^XN                               
; ------------------------------------------------ 
.TASK_DORSALFIN:
	LDA	TCB_HIT+TASK_BOSS_OVERLAY1
	BEQ	@F

	STA	<TEMP+2
	MOV	TCB_HIT+TASK_BOSS_OVERLAY1, #0

	; 쐬
	JSR	CRE_EXPLOSION

	LDA	TCB_COUNT1+TASK_BOSS_OVERLAY1
	SUB	<TEMP+2
	STA	TCB_COUNT1+TASK_BOSS_OVERLAY1
	BCS	@F
	DEC	TCB_COUNT0+TASK_BOSS_OVERLAY1
	BMI	.TASK_DORSALFIN_100

@@:
	ADD_TASK_QUE

	JSR	ADD_BOSS_HIT_QUE
	TSK_RET


.TASK_DORSALFIN_100:
	INC	TCB_COUNT3+TASK_BOSS
	LDY	TCB_COUNT3+TASK_BOSS
	LDA	.PAT_BASE,Y
	STA	TCB_COUNT2+TASK_BOSS

	; _
	LDA	#3
	LDX	#3
	JSR	ADD_SCORE

	; wr
	VRAM_PROC_ADD	BOSS0_WBG_DORSALFIN_PROC
	TSK_RET


; ------------------------------------------------ 
;   \r^XN                               
; ------------------------------------------------ 
.TASK_ANALFIN:
	LDA	TCB_HIT+TASK_BOSS_OVERLAY2
	BEQ	@F

	STA	<TEMP+2
	MOV	TCB_HIT+TASK_BOSS_OVERLAY2, #0

	; 쐬
	JSR	CRE_EXPLOSION

	LDA	TCB_COUNT1+TASK_BOSS_OVERLAY2
	SUB	<TEMP+2
	STA	TCB_COUNT1+TASK_BOSS_OVERLAY2
	BCS	@F
	DEC	TCB_COUNT1+TASK_BOSS_OVERLAY2
	BMI	.TASK_ANALFIN_100

@@:
	ADD_TASK_QUE

	JSR	ADD_BOSS_HIT_QUE
	TSK_RET


.TASK_ANALFIN_100:
	LDA	TCB_COUNT3+TASK_BOSS
	ORA	#2
	STA	TCB_COUNT3+TASK_BOSS
	TAY
	LDA	.PAT_BASE,Y
	STA	TCB_COUNT2+TASK_BOSS

	; _
	LDA	#3
	LDX	#3
	JSR	ADD_SCORE

	; \r
	VRAM_PROC_ADD	BOSS0_WBG_ANALFIN_PROC
	TSK_RET


.PAT_BASE	.DB	BOSS0_PAT_BASE0
		.DB	BOSS0_PAT_BASE1
		.DB	BOSS0_PAT_BASE2
		.DB	BOSS0_PAT_BASE3
