; ================================================================================ 
;   darius/src/define.inc                                                          
;                                                                                  
;   Copyright (C) 2017 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

STACK_SIZE		=	20				; X^bNTCY
TASK_MAX		=	64				; ^XNő吔

; ------------------------------------------------ 
;   pbh                                     
; ------------------------------------------------ 
PAD_A			=	1 << 7				; A {^
PAD_B			=	1 << 6				; B {^
PAD_SELECT		=	1 << 5				; SELECT {^
PAD_START		=	1 << 4				; START {^
PAD_UP			=	1 << 3				; 
PAD_DOWN		=	1 << 2				; 
PAD_LEFT		=	1 << 1				; 
PAD_RIGHT		=	1 << 0				; E


; ------------------------------------------------ 
;   葮                                     
; ------------------------------------------------ 
HIT_ATTR_SILVER_HAWK	=	1 << 7				; 肠
HIT_ATTR_MISSILE	=	1 << 6				; ~TCL
HIT_ATTR_LASER		=	1 << 5				; [U[L
HIT_ATTR_WAVE		=	1 << 4				; EF[uL
HIT_ATTR_BOMB		=	1 << 3				; {L
HIT_ATTR_DISAPPEAR	=	1 << 0				; 


; ------------------------------------------------ 
;   XvCgf[^                               
; ------------------------------------------------ 
	.RSSET	$0
SPR_YPOS		.RS	1				; XvCgW
SPR_PAT			.RS	1				; XvCgp^[ԍ
SPR_ATTR		.RS	1				; XvCg
SPR_XPOS		.RS	1				; XvCgW


; ------------------------------------------------ 
;   ^XNԍ                                     
; ------------------------------------------------ 
	.RSSET	$0
TASK_PLAYER		.RS	1				; vC[^XN
TASK_SHOOT		.RS	5				; Vbg^XN
TASK_BOMB_RD		.RS	2				; E{^XN
TASK_BOMB_RU		.RS	2				; E{^XN
TASK_BOMB_LD		.RS	2				; {^XN
TASK_BOMB_LU		.RS	2				; {^XN
TASK_BOSS		.RS	1				; {X^XN
TASK_BOSS_OVERLAY0	.RS	1				; {Xd˂O
TASK_BOSS_OVERLAY1	.RS	1				; {Xd˂P
TASK_BOSS_OVERLAY2	.RS	1				; {Xd˂Q
TASK_BOSS_OVERLAY3	.RS	1				; {Xd˂R
TASK_RESERVED_MAX	.RS	1				; \ő吔


; ------------------------------------------------ 
;   VRAM ]f[^                                
; ------------------------------------------------ 
	.RSSET	$0
VRAM_H			.RS	1				; ]ʃAhX
VRAM_L			.RS	1				; ]ʃAhX
VRAM_COUNT		.RS	1				; ]
VRAM_DATA		.RS	1				; ]f[^


; ------------------------------------------------ 
;   W VRAM AhXϊ                     
; ------------------------------------------------ 
POSTOVRAM		.FUNC	(\2) * 32 + (\1)


; ------------------------------------------------ 
;   ]                                           
; ------------------------------------------------ 
MOV	.MACRO
	.IF	\# = 2
		LDA	\2
		STA	\1
	.ELIF	\# = 4
		LDA	\3,\4
		STA	\1,\2
	.ELIF	\?2 = ARG_REG
		LDA	\3
		STA	\1,\2
	.ELSE
		LDA	\2,\3
		STA	\1
	.ENDIF
	.ENDM

MOV_X	.MACRO
	LDX	\2
	STX	\1
	.ENDM

MOV_Y	.MACRO
	LDY	\2
	STY	\1
	.ENDM


; ------------------------------------------------ 
;   Z                                           
; ------------------------------------------------ 
ADD	.MACRO
	CLC
	.IF	\# = 1
		ADC	\1
	.ELSE
		ADC	\1,\2
	.ENDIF
	.ENDM


ADD_X	.MACRO
	.IF	\1 = 1
		INX
	.ELIF	\1 = 2
		INX
		INX
	.ELIF	\1 = 3
		INX
		INX
		INX
	.ELIF	\1 = 4
		INX
		INX
		INX
		INX
	.ELSE
		TAX
		CLC
		ADC	\1
		TXA
	.ENDIF
	.ENDM


ADD_Y	.MACRO
	.IF	\1 = 1
		INY
	.ELIF	\1 = 2
		INY
		INY
	.ELIF	\1 = 3
		INY
		INY
		INY
	.ELIF	\1 = 4
		INY
		INY
		INY
		INY
	.ELSE
		TAY
		CLC
		ADC	\1
		TYA
	.ENDIF
	.ENDM


; ------------------------------------------------ 
;   Z                                           
; ------------------------------------------------ 
SUB	.MACRO
	SEC
	.IF	\# = 1
		SBC	\1
	.ELSE
		SBC	\1,\2
	.ENDIF
	.ENDM


SUB_X	.MACRO
	.IF	\1 = 1
		DEX
	.ELIF	\1 = 2
		DEX
		DEX
	.ELIF	\1 = 3
		DEX
		DEX
		DEX
	.ELIF	\1 = 4
		DEX
		DEX
		DEX
		DEX
	.ELSE
		TAX
		SEC
		SBC	\1
		TXA
	.ENDIF
	.ENDM


SUB_Y	.MACRO
	.IF	\1 = 1
		DEY
	.ELIF	\1 = 2
		DEY
		DEY
	.ELIF	\1 = 3
		DEY
		DEY
		DEY
	.ELIF	\1 = 4
		DEY
		DEY
		DEY
		DEY
	.ELSE
		TAY
		SEC
		SBC	\1
		TYA
	.ENDIF
	.ENDM


; ------------------------------------------------ 
;   PPU VRAM AhXݒ                          
; ------------------------------------------------ 
SET_VRAM_ADDR	.MACRO
	.IF	\# = 1
		LDA	#HIGH(\1)
		STA	PPU_REG_VRAM_ADDR
		LDA	#LOW(\1)
		STA	PPU_REG_VRAM_ADDR
	.ELSE
		LD\1	#HIGH(\2)
		ST\1	PPU_REG_VRAM_ADDR
		LD\1	#LOW(\2)
		ST\1	PPU_REG_VRAM_ADDR
	.ENDIF
	.ENDM


; ------------------------------------------------ 
;   pbg                               
; ------------------------------------------------ 
WRITE_PAL	.MACRO
	LDA	#LOW(PPU_BGPAL+\1)
	LDY	#\2
	JSR	WRITE_PAL_DATA
	.ENDM


; ------------------------------------------------ 
;   VXeύX                               
; ------------------------------------------------ 
SYS_CHG	.MACRO
	.IF	\# = 1
		LDA	#HIGH(\1)
		STA	<SYS_PROC_H
		LDA	#LOW(\1)
		STA	<SYS_PROC_L
	.ELSE
		LD\1	#HIGH(\2)
		ST\1	<SYS_PROC_H
		LD\1	#LOW(\2)
		ST\1	<SYS_PROC_L
	.ENDIF
	.ENDM


; ------------------------------------------------ 
;   VXe^[                               
; ------------------------------------------------ 
SYS_RET	.MACRO
	JMP	SYS_EXIT
	.ENDM


; ------------------------------------------------ 
;   OύX                                     
; ------------------------------------------------ 
PRE_CHG	.MACRO
	.IF	\# = 1
		LDA	#HIGH(\1)
		STA	<PRE_PROC_H
		LDA	#LOW(\1)
		STA	<PRE_PROC_L
	.ELSE
		LD\1	#HIGH(\2)
		ST\1	<PRE_PROC_H
		LD\1	#LOW(\2)
		ST\1	<PRE_PROC_L
	.ENDIF
	.ENDM


; ------------------------------------------------ 
;   O^[                                 
; ------------------------------------------------ 
PRE_RET	.MACRO
	JMP	PRE_EXIT
	.ENDM


; ------------------------------------------------ 
;   ㏈ύX                                     
; ------------------------------------------------ 
POST_CHG	.MACRO
	.IF	\# = 1
		LDA	#HIGH(\1)
		STA	<POST_PROC_H
		LDA	#LOW(\1)
		STA	<POST_PROC_L
	.ELSE
		LD\1	#HIGH(\2)
		ST\1	<POST_PROC_H
		LD\1	#LOW(\2)
		ST\1	<POST_PROC_L
	.ENDIF
	.ENDM


; ------------------------------------------------ 
;   ㏈^[                                 
; ------------------------------------------------ 
POST_RET	.MACRO
	JMP	POST_EXIT
	.ENDM


; ------------------------------------------------ 
;   VRAM ǉ                                  
; ------------------------------------------------ 
VRAM_PROC_ADD	.MACRO
	LDY	<VRAM_PROC_COUNT
	INC	<VRAM_PROC_COUNT
	LDA	#HIGH(\1)
	STA	VRAM_PROC_BUFF_H,Y
	LDA	#LOW(\1)
	STA	VRAM_PROC_BUFF_L,Y
	.ENDM


; ------------------------------------------------ 
;   VRAM ^[                              
; ------------------------------------------------ 
VRAM_PROC_RET	.MACRO
	JMP	VRAM_PROC_EXIT
	.ENDM


; ---------------------------------------------------------------- 
;   ^XN쐬                                                     
; ---------------------------------------------------------------- 
TSK_CRE	.MACRO
	DEC	<TASK_COUNT
	LD\1	<TASK_COUNT
	LDA	TASK_NO,\1

	LD\1	<TASK_QUE_W
	INC	<TASK_QUE_W
	STA	TASK_QUE,\1

	TA\1
	LDA	#HIGH(\2)
	STA	TCB_PROC_H,\1
	LDA	#LOW(\2)
	STA	TCB_PROC_L,\1
	.ENDM


; ---------------------------------------------------------------- 
;   ^XNύX                                                 
; ---------------------------------------------------------------- 
TSK_CHG	.MACRO
	.IF	\# = 1
		LDA	#HIGH(\1)
		STA	TCB_PROC_H,X
		LDA	#LOW(\1)
		STA	TCB_PROC_L,X
	.ELIF	\?1 = ARG_REG
		LDA	#HIGH(\2)
		STA	TCB_PROC_H,\1
		LDA	#LOW(\2)
		STA	TCB_PROC_L,\1
	.ELSE
		LDA	#HIGH(\2)
		STA	TCB_PROC_H+\1
		LDA	#LOW(\2)
		STA	TCB_PROC_L+\1
	.ENDIF
	.ENDM


; ---------------------------------------------------------------- 
;   ^XN^[                                                 
; ---------------------------------------------------------------- 
TSK_RET	.MACRO
	JMP	TASK_EXIT
	.ENDM


; ---------------------------------------------------------------- 
;   ^XNL[֒ǉ                                             
; ---------------------------------------------------------------- 
ADD_TASK_QUE	.MACRO
	.IF	\# = 0
		TXA
	.ELIF	\?1 = ARG_REG
		.IF	\1 != A
			T\1A
		.ENDIF
	.ELSE
		LDA	\1
	.ENDIF
	LDY	<TASK_QUE_W
	STA	TASK_QUE,Y
	INC	<TASK_QUE_W
	.ENDM


ADD_TASK_QUE_X	.MACRO
	.IF	\# = 0
		TYA
	.ELIF	\?1 = ARG_REG
		.IF	\1 != A
			T\1A
		.ENDIF
	.ELSE
		LDA	\1
	.ENDIF
	LDX	<TASK_QUE_W
	STA	TASK_QUE,X
	INC	<TASK_QUE_W
	.ENDM


; ---------------------------------------------------------------- 
;   ^XNԍԋp                                               
; ---------------------------------------------------------------- 
PUT_TASK_NO	.MACRO
	.IF	\# = 0
		TXA
	.ELSE
		LDA	\1
	.ENDIF
	LDY	<TASK_COUNT
	INC	<TASK_COUNT
	STA	TASK_NO,Y
	.ENDM
