; ================================================================================ 
;   darius/src/player.asm                                                          
;                                                                                  
;   Copyright (C) 2017 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

.OBLIQUE_SPEED		=	$170				; ΂߈ړx

	.CODE

; ---------------------------------------------------------------- 
;   Vbge^XNL[֒ǉ                           
;                                                                  
;   IN   : X = ^XNԍ                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, X, Y, TEMP+0                                         
; ---------------------------------------------------------------- 
.ADD_HIT_SHOOT:
	; ʊOȂI
	LDA	TCB_XPOS_H,X
	BNE	.ADD_HIT_BULLET_0F0

	; JnW
	LDA	TCB_YPOS_L,X
	ADD	<SHOOT_HIT_Y
	STA	<TEMP+0
	BCS	@F

	; Nbv
	LDA	#0
@@:
	STA	TCB_HIT_Y,X

	; IW
	LDA	<TEMP+0
	ADD	<SHOOT_HIT_H

	; 
	SUB	TCB_HIT_Y,X
	STA	TCB_HIT_H,X

	; e^XNL[֒ǉ
	LDY	<HIT_BULLET_COUNT
	INC	<HIT_BULLET_COUNT
	STX	<HIT_BULLET_QUE,Y

.ADD_HIT_BULLET_0F0:
	RTS


; ---------------------------------------------------------------- 
;   {e^XNL[֒ǉ                               
;                                                                  
;   IN   : X = ^XNԍ                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, X, Y, TEMP+0                                         
; ---------------------------------------------------------------- 
.ADD_HIT_BOMB:
	; ʊOȂI
	LDA	TCB_XPOS_H,X
	BNE	@F

	; JnW
	LDA	TCB_YPOS_L,X
	ADD	#-2
	STA	TCB_HIT_Y,X

	; e^XNL[֒ǉ
	LDY	<HIT_BULLET_COUNT
	INC	<HIT_BULLET_COUNT
	STX	<HIT_BULLET_QUE,Y

@@:
	RTS


; ---------------------------------------------------------------- 
;   Vo[z[N^XN쐬                                       
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A, X, Y                                                 
; ---------------------------------------------------------------- 
CRE_SILVER_HAWK:
	; Vo[z[N
	TSK_CHG	TASK_PLAYER, .TASK_SILVER_HAWK
	MOV	TCB_ACT+TASK_PLAYER,    #COMM_TBL_SILVERHAWK1
	MOV	TCB_SPEED+TASK_PLAYER,  #(2*4)
	MOV	TCB_XPOS_L+TASK_PLAYER, #32
	MOV	TCB_YPOS_L+TASK_PLAYER, #106
	MOV	TCB_XPOS_H+TASK_PLAYER, #0
	STA	TCB_XPOS_F+TASK_PLAYER
	STA	TCB_YPOS_H+TASK_PLAYER
	STA	TCB_YPOS_F+TASK_PLAYER
	STA	TCB_COUNT0+TASK_PLAYER
	STA	TCB_COUNT1+TASK_PLAYER
	MOV	TCB_HIT,                <ARM_COUNT
	MOV	TCB_HIT_ATTR,           #HIT_ATTR_SILVER_HAWK

	ADD_TASK_QUE	#TASK_PLAYER

	; VbgE{
	LDX	#TASK_SHOOT+(5+2*4)
	LDY	#(5+2*4)
@@:
	DEX
	MOV	TCB_COUNT0,X,   #2
	MOV	TCB_XPOS_H,X,   #0
	STA	TCB_XPOS_L,X
	STA	TCB_XPOS_F,X
	STA	TCB_YPOS_H,X
	STA	TCB_YPOS_L,X
	STA	TCB_YPOS_F,X
	STA	TCB_HIT_X,X
	STA	TCB_HIT_Y,X
	STA	TCB_HIT,X
	STA	TCB_HIT_W,X
	STA	TCB_HIT_H,X
	MOV	TCB_HIT_ATTR,X, #HIT_ATTR_BOMB
	TXA
	DEY
	STA	SHOOT_TASK_NO,Y
	BNE	@B

	; -------------------------------- 
	;   Vbg^XN           
	; -------------------------------- 
	LDA	<SHOOT_LEVEL
	LSR	A
	LSR	A
	LSR	A
	TAY
	LDA	.SHOOT_HIT_ATTR,Y
	STA	<TEMP+0

	MOV	<SHOOT_PROC_H, .SHOOT_PROC_H,Y
	MOV	<SHOOT_PROC_L, .SHOOT_PROC_L,Y

	LDX	<SHOOT_COUNT
@@:
	MOV	TCB_PROC_H  +TASK_SHOOT-1,X, <SHOOT_PROC_H
	MOV	TCB_PROC_L  +TASK_SHOOT-1,X, <SHOOT_PROC_L
	MOV	TCB_PAT     +TASK_SHOOT-1,X, <SHOOT_PAT
	MOV	TCB_HIT_H   +TASK_SHOOT-1,X, #4
	MOV	TCB_HIT_ATTR+TASK_SHOOT-1,X, <TEMP+0
	DEX
	BNE	@B

	; -------------------------------- 
	;   {^XN               
	; -------------------------------- 
	MOV	<BOMB_RD_COUNT, #2
	STA	<BOMB_RU_COUNT
	STA	<BOMB_LD_COUNT
	STA	<BOMB_LU_COUNT
	LDX	#0
@@:
	; {E
	MOV	TCB_PROC_H  +TASK_BOMB_RD,X, #HIGH(.TASK_BOMB_RD)
	MOV	TCB_PROC_L  +TASK_BOMB_RD,X, #LOW(.TASK_BOMB_RD)
	MOV	TCB_COUNT0  +TASK_BOMB_RD,X, #0
	MOV	TCB_COUNT1  +TASK_BOMB_RD,X, #2
	MOV	TCB_COUNT3  +TASK_BOMB_RD,X, #COMM_PAT_BOMB0
	STA	TCB_PAT     +TASK_BOMB_RD,X

	; {E
	MOV	TCB_PROC_H  +TASK_BOMB_RU,X, #HIGH(.TASK_BOMB_RU)
	MOV	TCB_PROC_L  +TASK_BOMB_RU,X, #LOW(.TASK_BOMB_RU)
	MOV	TCB_COUNT0  +TASK_BOMB_RU,X, #1
	MOV	TCB_COUNT1  +TASK_BOMB_RU,X, #2
	MOV	TCB_COUNT3  +TASK_BOMB_RU,X, #COMM_PAT_BOMB1
	STA	TCB_PAT     +TASK_BOMB_RU,X

	; {
	MOV	TCB_PROC_H  +TASK_BOMB_LD,X, #HIGH(.TASK_BOMB_LD)
	MOV	TCB_PROC_L  +TASK_BOMB_LD,X, #LOW(.TASK_BOMB_LD)
	MOV	TCB_COUNT0  +TASK_BOMB_LD,X, #2
	MOV	TCB_COUNT1  +TASK_BOMB_LD,X, #2
	MOV	TCB_COUNT3  +TASK_BOMB_LD,X, #COMM_PAT_BOMB2
	STA	TCB_PAT     +TASK_BOMB_LD,X

	; {
	MOV	TCB_PROC_H  +TASK_BOMB_LU,X, #HIGH(.TASK_BOMB_LU)
	MOV	TCB_PROC_L  +TASK_BOMB_LU,X, #LOW(.TASK_BOMB_LU)
	MOV	TCB_COUNT0  +TASK_BOMB_LU,X, #3
	MOV	TCB_COUNT1  +TASK_BOMB_LU,X, #2
	MOV	TCB_COUNT3  +TASK_BOMB_LU,X, #COMM_PAT_BOMB3
	STA	TCB_PAT     +TASK_BOMB_LU,X

	INX
	CPX	#2
	BNE	@B

	; {^XN쐬
	LDA	<BOMB_LEVEL
	LSR	A
	LSR	A
	LSR	A
	TAX
	MOV	CRE_BOMB_PROC+1, .CRE_BOMB_PROC_H,X
	MOV	CRE_BOMB_PROC+0, .CRE_BOMB_PROC_L,X

	; A[pbg^XN쐬
	TSK_CRE	Y, .TASK_ARM_PAL
	MOV	TCB_COUNT0,Y, #0
	RTS


; ------------------------------------------------ 
;   Vo[z[N^XN                       
; ------------------------------------------------ 
.TASK_SILVER_HAWK:
	ADD_TASK_QUE

	; p^[XV
	LDA	TCB_PAT_COUNT+TASK_PLAYER
	AND	#3
	ADD	TCB_ACT+TASK_PLAYER
	TAY
	MOV	TCB_PAT+TASK_PLAYER, COMM_TBL_PAT,Y
	INC	TCB_PAT_COUNT+TASK_PLAYER

	LDA	TCB_COUNT1+TASK_PLAYER
	BEQ	.TASK_SILVER_HAWK_080

.TASK_SILVER_HAWK_000:
	; _ŕ\
	DEC	TCB_COUNT1+TASK_PLAYER
	LDA	TCB_COUNT1+TASK_PLAYER
	AND	#16
	BEQ	.TASK_SILVER_HAWK_0F0

	JSR	SET_SPR_BUFF
	JMP	.TASK_SILVER_HAWK_0F0

.TASK_SILVER_HAWK_080:
	; ʏ\
	INC	<HIT_PLAYER
	JSR	SET_SPR_BUFF

.TASK_SILVER_HAWK_0F0:
	LDA	<PAD_NORM
	AND	#15
	TAY
	MOV	<TEMP+1, .TASK_SILVER_HAWK_PROC_H,Y
	MOV	<TEMP+0, .TASK_SILVER_HAWK_PROC_L,Y
	JMP	(TEMP)


	; -------------------------------- 
	;   Eֈړ                       
	; -------------------------------- 
.TASK_SILVER_HAWK_R:
	LDA	TCB_XPOS_L+TASK_PLAYER
	ADD	#2
	CMP	#232
	BCC	@F

	LDA	#232
@@:
	STA	TCB_XPOS_L+TASK_PLAYER
	JMP	.TASK_SILVER_HAWK_100


	; -------------------------------- 
	;   Eֈړ                     
	; -------------------------------- 
.TASK_SILVER_HAWK_RD:
	LDA	TCB_XPOS_F+TASK_PLAYER
	ADD	#LOW(.OBLIQUE_SPEED)
	STA	TCB_XPOS_F+TASK_PLAYER
	LDA	TCB_XPOS_L+TASK_PLAYER
	ADC	#HIGH(.OBLIQUE_SPEED)
	CMP	#232
	BCC	@F

	LDA	#232
@@:
	STA	TCB_XPOS_L+TASK_PLAYER

.TASK_SILVER_HAWK_RD_D:
	; 
	LDA	TCB_YPOS_F+TASK_PLAYER
	ADD	#LOW(.OBLIQUE_SPEED)
	STA	TCB_YPOS_F+TASK_PLAYER
	LDA	TCB_YPOS_L+TASK_PLAYER
	ADC	#HIGH(.OBLIQUE_SPEED)
	CMP	#200
	BCC	@F

	LDA	#200
@@:
	STA	TCB_YPOS_L+TASK_PLAYER
	JMP	.TASK_SILVER_HAWK_100


	; -------------------------------- 
	;   ֈړ                       
	; -------------------------------- 
.TASK_SILVER_HAWK_D:
	LDA	TCB_YPOS_L+TASK_PLAYER
	ADD	#2
	CMP	#200
	BCC	@F

	LDA	#200
@@:
	STA	TCB_YPOS_L+TASK_PLAYER
	JMP	.TASK_SILVER_HAWK_100


	; -------------------------------- 
	;   ֈړ                     
	; -------------------------------- 
.TASK_SILVER_HAWK_LD:
	; 
	LDA	TCB_XPOS_F+TASK_PLAYER
	SUB	#LOW(.OBLIQUE_SPEED)
	STA	TCB_XPOS_F+TASK_PLAYER
	LDA	TCB_XPOS_L+TASK_PLAYER
	SBC	#HIGH(.OBLIQUE_SPEED)
	BCS	@F

	LDA	#0
@@:
	STA	TCB_XPOS_L+TASK_PLAYER

	JMP	.TASK_SILVER_HAWK_RD_D


	; -------------------------------- 
	;   ֈړ                       
	; -------------------------------- 
.TASK_SILVER_HAWK_L:
	LDA	TCB_XPOS_L+TASK_PLAYER
	SUB	#2
	BCS	@F

	LDA	#0
@@:
	STA	TCB_XPOS_L+TASK_PLAYER
	JMP	.TASK_SILVER_HAWK_100


	; -------------------------------- 
	;   ֈړ                     
	; -------------------------------- 
.TASK_SILVER_HAWK_LU:
	; 
	LDA	TCB_XPOS_F+TASK_PLAYER
	SUB	#LOW(.OBLIQUE_SPEED)
	STA	TCB_XPOS_F+TASK_PLAYER
	LDA	TCB_XPOS_L+TASK_PLAYER
	SBC	#HIGH(.OBLIQUE_SPEED)
	BCS	@F

	LDA	#0
@@:
	STA	TCB_XPOS_L+TASK_PLAYER

	JMP	.TASK_SILVER_HAWK_RU_U


	; -------------------------------- 
	;   ֈړ                       
	; -------------------------------- 
.TASK_SILVER_HAWK_U:
	LDA	TCB_YPOS_L+TASK_PLAYER
	SUB	#2
	CMP	#8
	BCS	@F

	LDA	#8
@@:
	STA	TCB_YPOS_L+TASK_PLAYER
	JMP	.TASK_SILVER_HAWK_100


	; -------------------------------- 
	;   Eֈړ                     
	; -------------------------------- 
.TASK_SILVER_HAWK_RU:
	; E
	LDA	TCB_XPOS_F+TASK_PLAYER
	ADD	#LOW(.OBLIQUE_SPEED)
	STA	TCB_XPOS_F+TASK_PLAYER
	LDA	TCB_XPOS_L+TASK_PLAYER
	ADC	#HIGH(.OBLIQUE_SPEED)
	CMP	#232
	BCC	@F

	LDA	#232
@@:
	STA	TCB_XPOS_L+TASK_PLAYER

.TASK_SILVER_HAWK_RU_U:
	; 
	LDA	TCB_YPOS_F+TASK_PLAYER
	SUB	#LOW(.OBLIQUE_SPEED)
	STA	TCB_YPOS_F+TASK_PLAYER
	LDA	TCB_YPOS_L+TASK_PLAYER
	SBC	#HIGH(.OBLIQUE_SPEED)
	CMP	#8
	BCS	@F

	LDA	#8
@@:
	STA	TCB_YPOS_L+TASK_PLAYER

.TASK_SILVER_HAWK_100:

	; -------------------------------- 
	;   Vbg                       
	; -------------------------------- 
	LDA	#PAD_A
	BIT	<PAD_ONCE
	BEQ	@F

	LDX	<SHOOT_COUNT
	BEQ	@F

	DEX
	STX	<SHOOT_COUNT
	LDA	SHOOT_TASK_NO,X

	ADD_TASK_QUE	A

	TAX
	LDA	TCB_XPOS_L+TASK_PLAYER
	ADD	#12
	STA	TCB_XPOS_L,X
	MOV	TCB_YPOS_L,X, TCB_YPOS_L+TASK_PLAYER

	; -------------------------------- 
	;   {                           
	; -------------------------------- 
@@:	LDA	#PAD_B
	BIT	<PAD_ONCE
	BEQ	.TASK_SILVER_HAWK_1F0

	LDA	<PAD_NORM
	AND	#(PAD_LEFT|PAD_RIGHT)
	TAY
	JMP	(CRE_BOMB_PROC)

.TASK_SILVER_HAWK_1F0:
	TSK_RET


; ------------------------------------------------ 
;   Vo[z[Nꏈ                         
; ------------------------------------------------ 
TASK_SILVER_HAWK_BROKEN:
	TSK_CHG	TASK_PLAYER, .TASK_SILVER_HAWK_BROKEN_000

	ADD_TASK_QUE

	LDA	#COMM_TBL_EXPLOSION_L
	JSR	SET_ACT
	JSR	SET_SPR_BUFF
	TSK_RET


.TASK_SILVER_HAWK_BROKEN_000:
	ADD_TASK_QUE

	JSR	ACT_TASK
	BCS	@F

	JSR	SET_SPR_BUFF
	TSK_RET

@@:
	TSK_CHG	TASK_PLAYER, .TASK_SILVER_HAWK_BROKEN_100
	MOV	TCB_COUNT1+TASK_PLAYER, #30
	TSK_RET


.TASK_SILVER_HAWK_BROKEN_100:
	DEC	TCB_COUNT1+TASK_PLAYER
	BEQ	@F

	ADD_TASK_QUE
	TSK_RET

@@:
	DEC	<PLAYER_COUNT
	BPL	@F

	; Q[I[o[
	SYS_CHG	SYSTEM_GAMEOVER
	TSK_RET

@@:
	TSK_CHG	TASK_PLAYER, .TASK_SILVER_HAWK
	MOV	TCB_ACT   +TASK_PLAYER, #COMM_TBL_SILVERHAWK0
	MOV	TCB_XPOS_L+TASK_PLAYER, #64
	MOV	TCB_YPOS_L+TASK_PLAYER, #60
	MOV	TCB_XPOS_H+TASK_PLAYER, #0
	STA	TCB_XPOS_F+TASK_PLAYER
	STA	TCB_YPOS_H+TASK_PLAYER
	STA	TCB_YPOS_F+TASK_PLAYER
	STA	TCB_HIT   +TASK_PLAYER
	STA	TCB_COUNT0+TASK_PLAYER
	MOV	TCB_COUNT1+TASK_PLAYER, #(60*2)

	ADD_TASK_QUE

	; c@`
	LDY	<VRAM_DATA_COUNT

	MOV	VRAM_DATA_BUFF+VRAM_H,Y,     #HIGH($2043)
	MOV	VRAM_DATA_BUFF+VRAM_L,Y,     #LOW($2043)
	MOV	VRAM_DATA_BUFF+VRAM_COUNT,Y, #1
	LDA	<PLAYER_COUNT
	ADD	#$30
	STA	VRAM_DATA_BUFF+VRAM_DATA,Y
	ADD_Y	#4

	STY	<VRAM_DATA_COUNT
	TSK_RET


; ------------------------------------------------ 
;   Vbg^XNŏ                         
; ------------------------------------------------ 
.TASK_MISSILE_DISAPPEAR:
	AND	#HIT_ATTR_DISAPPEAR
	BEQ	.TASK_SHOOT_F00

	TSK_CHG	.TASK_MISSILE_DISAPPEAR_000

	ADD_TASK_QUE

	LDA	#COMM_TBL_DISAPPEAR
	JSR	SET_ACT
	JSR	SET_SPR_BUFF
	TSK_RET


.TASK_MISSILE_DISAPPEAR_000:
	JSR	ACT_TASK
	BCS	.TASK_SHOOT_F00

	ADD_TASK_QUE

	JSR	SET_SPR_BUFF
	TSK_RET


; ------------------------------------------------ 
;   ~TC^XN                             
; ------------------------------------------------ 
.TASK_MISSILE:
	; G
	LDA	TCB_HIT,X
	BNE	.TASK_MISSILE_DISAPPEAR

	; ړ
	LDA	<SHOOT_SPEED_F
	ADD	TCB_XPOS_F,X
	STA	TCB_XPOS_F,X
	LDA	<SHOOT_SPEED
	ADC	TCB_XPOS_L,X
	STA	TCB_XPOS_L,X
	BCC	@F

	INC	TCB_XPOS_H,X
	LDA	TCB_XPOS_H,X
	CMP	#2
	BEQ	.TASK_SHOOT_F00
@@:
	ADD_TASK_QUE
	JSR	.ADD_HIT_SHOOT
	JSR	SET_SPR_BUFF
	TSK_RET


.TASK_SHOOT_F00:
	MOV	TCB_PROC_H,X, <SHOOT_PROC_H
	MOV	TCB_PROC_L,X, <SHOOT_PROC_L
	MOV	TCB_PAT,X,    <SHOOT_PAT
	MOV	TCB_XPOS_H,X, #0
	STA	TCB_XPOS_F,X
	STA	TCB_YPOS_H,X
	STA	TCB_YPOS_F,X
	STA	TCB_COUNT0,X
	STA	TCB_HIT,X

	; ^XNԍԋp
	TXA
	LDY	<SHOOT_COUNT
	INC	<SHOOT_COUNT
	STA	SHOOT_TASK_NO,Y
	TSK_RET


; ------------------------------------------------ 
;   EF[u^XN                             
; ------------------------------------------------ 
.TASK_WAVE:
	LDY	<SHOOT_TBL

	INC	TCB_COUNT0,X
	LDA	TCB_COUNT0,X
	AND	#4
	BEQ	@F

	INY
@@:
	MOV	TCB_PAT,X, COMM_TBL_PAT,Y

; ------------------------------------------------ 
;   [U[^XN                             
; ------------------------------------------------ 
.TASK_LASER:
	; ړ
	LDA	<SHOOT_SPEED_F
	ADD	TCB_XPOS_F,X
	STA	TCB_XPOS_F,X
	LDA	<SHOOT_SPEED
	ADC	TCB_XPOS_L,X
	STA	TCB_XPOS_L,X
	BCC	@F

	INC	TCB_XPOS_H,X
	LDA	TCB_XPOS_H,X
	CMP	#2
	BEQ	.TASK_SHOOT_F00
@@:
	ADD_TASK_QUE
	JSR	.ADD_HIT_SHOOT
	JSR	SET_SPR_BUFF
	TSK_RET


; ---------------------------------------------------------------- 
;   {^XN쐬                                             
;                                                                  
;   IN   : Y = pbhE                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, X                                                    
; ---------------------------------------------------------------- 
.CRE_BOMB_LU:
	LDX	<BOMB_LU_COUNT
	BEQ	.CRE_BOMB_LD

	DEX
	STX	<BOMB_LU_COUNT
	LDA	BOMB_LU_TASK_NO,X

	ADD_TASK_QUE_X	A

	TAX
	LDA	TCB_XPOS_L+TASK_PLAYER
	SUB	#10
	STA	TCB_XPOS_L,X
	BCS	@F

	DEC	TCB_XPOS_H,X
@@:
	LDA	TCB_YPOS_L+TASK_PLAYER
	ADD	#-6
	STA	TCB_YPOS_L,X

	MOV	TCB_ANGLE,X,  .BOMB_DATA_LU_ANGLE,Y
	MOV	TCB_SPEED,X,  .BOMB_DATA_LU_SPEED,Y
	MOV	TCB_COUNT2,X, .BOMB_DATA_LU_MAX,Y

; ---------------------------------------------------------------- 
;   {^XN쐬                                             
;                                                                  
;   IN   : Y = pbhE                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, X                                                    
; ---------------------------------------------------------------- 
.CRE_BOMB_LD:
	LDX	<BOMB_LD_COUNT
	BEQ	.CRE_BOMB_RU

	DEX
	STX	<BOMB_LD_COUNT
	LDA	BOMB_LD_TASK_NO,X

	ADD_TASK_QUE_X	A

	TAX
	LDA	TCB_XPOS_L+TASK_PLAYER
	SUB	#10
	STA	TCB_XPOS_L,X
	BCS	@F

	DEC	TCB_XPOS_H,X
@@:
	LDA	TCB_YPOS_L+TASK_PLAYER
	ADD	#6
	STA	TCB_YPOS_L,X

	MOV	TCB_ANGLE,X,  .BOMB_DATA_LD_ANGLE,Y
	MOV	TCB_SPEED,X,  .BOMB_DATA_LD_SPEED,Y
	MOV	TCB_COUNT2,X, .BOMB_DATA_LD_MAX,Y

; ---------------------------------------------------------------- 
;   E{^XN쐬                                             
;                                                                  
;   IN   : Y = pbhE                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, X                                                    
; ---------------------------------------------------------------- 
.CRE_BOMB_RU:
	LDX	<BOMB_RU_COUNT
	BEQ	.CRE_BOMB_RD

	DEX
	STX	<BOMB_RU_COUNT
	LDA	BOMB_RU_TASK_NO,X

	ADD_TASK_QUE_X	A

	TAX
	LDA	TCB_XPOS_L+TASK_PLAYER
	ADD	#10
	STA	TCB_XPOS_L,X

	LDA	TCB_YPOS_L+TASK_PLAYER
	ADD	#-6
	STA	TCB_YPOS_L,X

	MOV	TCB_ANGLE,X,  .BOMB_DATA_RU_ANGLE,Y
	MOV	TCB_SPEED,X,  .BOMB_DATA_RU_SPEED,Y
	MOV	TCB_COUNT2,X, .BOMB_DATA_RU_MAX,Y

; ---------------------------------------------------------------- 
;   E{^XN쐬                                             
;                                                                  
;   IN   : Y = pbhE                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, X                                                    
; ---------------------------------------------------------------- 
.CRE_BOMB_RD:
	LDX	<BOMB_RD_COUNT
	BEQ	.CRE_BOMB_0F0

	DEX
	STX	<BOMB_RD_COUNT
	LDA	BOMB_RD_TASK_NO,X

	ADD_TASK_QUE_X	A

	TAX
	LDA	TCB_XPOS_L+TASK_PLAYER
	ADD	#10
	STA	TCB_XPOS_L,X

	LDA	TCB_YPOS_L+TASK_PLAYER
	ADD	#6
	STA	TCB_YPOS_L,X

	MOV	TCB_ANGLE,X,  .BOMB_DATA_RD_ANGLE,Y
	MOV	TCB_SPEED,X,  .BOMB_DATA_RD_SPEED,Y
	MOV	TCB_COUNT2,X, .BOMB_DATA_RD_MAX,Y

.CRE_BOMB_0F0:
	TSK_RET


; ------------------------------------------------ 
;   {E^XN                             
; ------------------------------------------------ 
.TASK_BOMB_RD:
	; G
	LDA	TCB_HIT,X
	BNE	.TASK_BOMB_RD_0F0

	JSR	MOVE_ANGLE

	; ʊOȂ폜
	LDA	TCB_YPOS_L,X
	CMP	<WALL_BOTTOM
	BCS	.TASK_DEL_BOMB_RD

	ADD_TASK_QUE
	JSR	.ADD_HIT_BOMB
	JSR	SET_SPR_BUFF

	DEC	TCB_COUNT1,X
	BNE	@F

	MOV	TCB_COUNT1,X, #2
	INC	TCB_SPEED,X
@@:
	LDY	TCB_ANGLE,X
	ADD_Y	#2
	TYA
	CMP	TCB_COUNT2,X
	BCC	@F

	TSK_CHG	.TASK_BOMB_RD_000
	LDA	TCB_COUNT2,X
@@:
	STA	TCB_ANGLE,X
	TSK_RET


.TASK_BOMB_RD_000:
	; G
	LDA	TCB_HIT,X
	BNE	.TASK_BOMB_RD_0F0

	JSR	MOVE_ANGLE

	; ʊOȂ폜
	LDA	TCB_YPOS_L,X
	CMP	<WALL_BOTTOM
	BCS	.TASK_DEL_BOMB_RD

	ADD_TASK_QUE
	JSR	.ADD_HIT_BOMB
	JSR	SET_SPR_BUFF
	TSK_RET


.TASK_BOMB_RD_0F0:
	AND	#HIT_ATTR_DISAPPEAR
	BEQ	.TASK_DEL_BOMB_RD
	JMP	.TASK_BOMB_DISAPPEAR


.TASK_DEL_BOMB_RD:
	TXA
	LDY	<BOMB_RD_COUNT
	INC	<BOMB_RD_COUNT
	STA	BOMB_RD_TASK_NO,Y
	JMP	.TASK_DEL_BOMB


; ------------------------------------------------ 
;   {E^XN                             
; ------------------------------------------------ 
.TASK_BOMB_RU:
	; G
	LDA	TCB_HIT,X
	BNE	.TASK_BOMB_RU_0F0

	JSR	MOVE_ANGLE

	; ʊOȂ폜
	LDA	TCB_YPOS_L,X
	CMP	<WALL_TOP
	BCC	.TASK_DEL_BOMB_RU

	ADD_TASK_QUE
	JSR	.ADD_HIT_BOMB
	JSR	SET_SPR_BUFF

	DEC	TCB_COUNT1,X
	BNE	@F

	MOV	TCB_COUNT1,X, #2
	INC	TCB_SPEED,X
@@:
	LDY	TCB_ANGLE,X
	SUB_Y	#2
	TYA
	CMP	TCB_COUNT2,X
	BCS	@F

	TSK_CHG	.TASK_BOMB_RU_000
	LDA	TCB_COUNT2,X
@@:
	STA	TCB_ANGLE,X
	TSK_RET


.TASK_BOMB_RU_000:
	; G
	LDA	TCB_HIT,X
	BNE	.TASK_BOMB_RU_0F0

	JSR	MOVE_ANGLE

	; ʊOȂ폜
	LDA	TCB_YPOS_L,X
	CMP	<WALL_TOP
	BCC	.TASK_DEL_BOMB_RU

	ADD_TASK_QUE
	JSR	.ADD_HIT_BOMB
	JSR	SET_SPR_BUFF
	TSK_RET


.TASK_BOMB_RU_0F0:
	AND	#HIT_ATTR_DISAPPEAR
	BEQ	.TASK_DEL_BOMB_RU
	JMP	.TASK_BOMB_DISAPPEAR


.TASK_DEL_BOMB_RU:
	TXA
	LDY	<BOMB_RU_COUNT
	INC	<BOMB_RU_COUNT
	STA	BOMB_RU_TASK_NO,Y
	JMP	.TASK_DEL_BOMB


; ------------------------------------------------ 
;   {^XN                             
; ------------------------------------------------ 
.TASK_BOMB_LD:
	; G
	LDA	TCB_HIT,X
	BNE	.TASK_BOMB_LD_0F0

	JSR	MOVE_ANGLE

	; ʊOȂ폜
	LDA	TCB_YPOS_L,X
	CMP	<WALL_BOTTOM
	BCS	.TASK_DEL_BOMB_LD

	ADD_TASK_QUE
	JSR	.ADD_HIT_BOMB
	JSR	SET_SPR_BUFF

	DEC	TCB_COUNT1,X
	BNE	@F

	MOV	TCB_COUNT1,X, #2
	INC	TCB_SPEED,X
@@:
	LDY	TCB_ANGLE,X
	SUB_Y	#2
	TYA
	CMP	TCB_COUNT2,X
	BCS	@F

	TSK_CHG	.TASK_BOMB_LD_000
	LDA	TCB_COUNT2,X
@@:
	STA	TCB_ANGLE,X
	TSK_RET


.TASK_BOMB_LD_000:
	; G
	LDA	TCB_HIT,X
	BNE	.TASK_BOMB_LD_0F0

	JSR	MOVE_ANGLE

	; ʊOȂ폜
	LDA	TCB_YPOS_L,X
	CMP	<WALL_BOTTOM
	BCS	.TASK_DEL_BOMB_LD

	ADD_TASK_QUE
	JSR	.ADD_HIT_BOMB
	JSR	SET_SPR_BUFF
	TSK_RET


.TASK_BOMB_LD_0F0:
	AND	#HIT_ATTR_DISAPPEAR
	BEQ	.TASK_DEL_BOMB_LD
	JMP	.TASK_BOMB_DISAPPEAR


.TASK_DEL_BOMB_LD:
	TXA
	LDY	<BOMB_LD_COUNT
	INC	<BOMB_LD_COUNT
	STA	BOMB_LD_TASK_NO,Y
	JMP	.TASK_DEL_BOMB


; ------------------------------------------------ 
;   {^XN                             
; ------------------------------------------------ 
.TASK_BOMB_LU:
	; G
	LDA	TCB_HIT,X
	BNE	.TASK_BOMB_LU_0F0

	JSR	MOVE_ANGLE

	; ʊOȂ폜
	LDA	TCB_YPOS_L,X
	CMP	<WALL_TOP
	BCC	.TASK_DEL_BOMB_LU

	ADD_TASK_QUE
	JSR	.ADD_HIT_BOMB
	JSR	SET_SPR_BUFF

	DEC	TCB_COUNT1,X
	BNE	@F

	MOV	TCB_COUNT1,X, #2
	INC	TCB_SPEED,X
@@:
	LDY	TCB_ANGLE,X
	ADD_Y	#2
	TYA
	CMP	TCB_COUNT2,X
	BCC	@F

	TSK_CHG	.TASK_BOMB_LU_000
	LDA	TCB_COUNT2,X
@@:
	STA	TCB_ANGLE,X
	TSK_RET


.TASK_BOMB_LU_000:
	; G
	LDA	TCB_HIT,X
	BNE	.TASK_BOMB_LU_0F0

	JSR	MOVE_ANGLE

	; ʊOȂ폜
	LDA	TCB_YPOS_L,X
	CMP	<WALL_TOP
	BCC	.TASK_DEL_BOMB_LU

	ADD_TASK_QUE
	JSR	.ADD_HIT_BOMB
	JSR	SET_SPR_BUFF
	TSK_RET


.TASK_BOMB_LU_0F0:
	AND	#HIT_ATTR_DISAPPEAR
	BEQ	.TASK_DEL_BOMB_LU
	JMP	.TASK_BOMB_DISAPPEAR


.TASK_DEL_BOMB_LU:
	TXA
	LDY	<BOMB_LU_COUNT
	INC	<BOMB_LU_COUNT
	STA	BOMB_LU_TASK_NO,Y


; ------------------------------------------------ 
;   {^XN폜                             
; ------------------------------------------------ 
.TASK_DEL_BOMB:
	LDY	TCB_COUNT0,X
	MOV	TCB_PROC_H,X, .TASK_BOMB_H,Y
	MOV	TCB_PROC_L,X, .TASK_BOMB_L,Y
	MOV	TCB_XPOS_H,X, #0
	STA	TCB_XPOS_F,X
	STA	TCB_YPOS_H,X
	STA	TCB_YPOS_F,X
	STA	TCB_HIT,X
	MOV	TCB_COUNT1,X, #2
	MOV	TCB_PAT,X,    TCB_COUNT3,X
	TSK_RET


.TASK_BOMB_DISAPPEAR:
	TSK_CHG	.TASK_BOMB_DISAPPEAR_000

	ADD_TASK_QUE

	LDA	#COMM_TBL_DISAPPEAR
	JSR	SET_ACT
	JSR	SET_SPR_BUFF
	TSK_RET


.TASK_BOMB_DISAPPEAR_000:
	JSR	ACT_TASK
	BCS	@F

	ADD_TASK_QUE

	JSR	SET_SPR_BUFF
	TSK_RET

@@:
	LDY	TCB_COUNT0,X
	MOV	<TEMP+1, .TASK_DEL_BOMB_H,Y
	MOV	<TEMP+0, .TASK_DEL_BOMB_L,Y
	JMP	(TEMP)


; ------------------------------------------------ 
;   A[pbg^XN                       
; ------------------------------------------------ 
.TASK_ARM_PAL:
	ADD_TASK_QUE

	LDY	<ARM_PAL

	; _[W
	LDA	TCB_COUNT3+TASK_PLAYER
	BEQ	@F

	DEC	TCB_COUNT3+TASK_PLAYER
	LDY	#10
@@:
	STY	<TEMP+0

	LDA	TCB_COUNT0,X
	INC	TCB_COUNT0,X
	LSR	A
	BCS	.TASK_ARM_PAL_0F0
	LSR	A
	BCS	.TASK_ARM_PAL_0F0

	CMP	#3
	BNE	@F

	MOV	TCB_COUNT0,X, #1
	LDA	#0
@@:
	ADD	<TEMP+0
	TAY

	LDA	#LOW($3F1D)
	JSR	SET_PAL_DATA

.TASK_ARM_PAL_0F0:
	TSK_RET


; v[[ړ
.TASK_SILVER_HAWK_PROC_H:
			.DB	HIGH(.TASK_SILVER_HAWK_100)			;
			.DB	HIGH(.TASK_SILVER_HAWK_R)			; PAD_RIGHT
			.DB	HIGH(.TASK_SILVER_HAWK_L)			; PAD_LEFT
			.DB	HIGH(.TASK_SILVER_HAWK_100)			;
			.DB	HIGH(.TASK_SILVER_HAWK_D)			; PAD_DOWN
			.DB	HIGH(.TASK_SILVER_HAWK_RD)			; PAD_RIGHT/PAD_DOWN
			.DB	HIGH(.TASK_SILVER_HAWK_LD)			; PAD_LEFT /PAD_DOWN
			.DB	HIGH(.TASK_SILVER_HAWK_100)			;
			.DB	HIGH(.TASK_SILVER_HAWK_U)			; PAD_UP
			.DB	HIGH(.TASK_SILVER_HAWK_RU)			; PAD_RIGHT/PAD_UP
			.DB	HIGH(.TASK_SILVER_HAWK_LU)			; PAD_LEFT /PAD_UP
			.DB	HIGH(.TASK_SILVER_HAWK_100)			;
			.DB	HIGH(.TASK_SILVER_HAWK_100)			;
			.DB	HIGH(.TASK_SILVER_HAWK_100)			;
			.DB	HIGH(.TASK_SILVER_HAWK_100)			;
			.DB	HIGH(.TASK_SILVER_HAWK_100)			;

; v[[ړ
.TASK_SILVER_HAWK_PROC_L:
			.DB	 LOW(.TASK_SILVER_HAWK_100)			;
			.DB	 LOW(.TASK_SILVER_HAWK_R)			; PAD_RIGHT
			.DB	 LOW(.TASK_SILVER_HAWK_L)			; PAD_LEFT
			.DB	 LOW(.TASK_SILVER_HAWK_100)			;
			.DB	 LOW(.TASK_SILVER_HAWK_D)			; PAD_DOWN
			.DB	 LOW(.TASK_SILVER_HAWK_RD)			; PAD_RIGHT/PAD_DOWN
			.DB	 LOW(.TASK_SILVER_HAWK_LD)			; PAD_LEFT /PAD_DOWN
			.DB	 LOW(.TASK_SILVER_HAWK_100)			;
			.DB	 LOW(.TASK_SILVER_HAWK_U)			; PAD_UP
			.DB	 LOW(.TASK_SILVER_HAWK_RU)			; PAD_RIGHT/PAD_UP
			.DB	 LOW(.TASK_SILVER_HAWK_LU)			; PAD_LEFT /PAD_UP
			.DB	 LOW(.TASK_SILVER_HAWK_100)			;
			.DB	 LOW(.TASK_SILVER_HAWK_100)			;
			.DB	 LOW(.TASK_SILVER_HAWK_100)			;
			.DB	 LOW(.TASK_SILVER_HAWK_100)			;
			.DB	 LOW(.TASK_SILVER_HAWK_100)			;

; Vbg^XN
.SHOOT_PROC_H:	.DB	HIGH(.TASK_MISSILE), HIGH(.TASK_LASER), HIGH(.TASK_WAVE)
.SHOOT_PROC_L:	.DB	 LOW(.TASK_MISSILE),  LOW(.TASK_LASER),  LOW(.TASK_WAVE)

; {쐬
.CRE_BOMB_PROC_H:	.DB	HIGH(.CRE_BOMB_RD), HIGH(.CRE_BOMB_RU), HIGH(.CRE_BOMB_LU)
.CRE_BOMB_PROC_L:	.DB	 LOW(.CRE_BOMB_RD),  LOW(.CRE_BOMB_RU),  LOW(.CRE_BOMB_LU)

; {ړ
.TASK_BOMB_H:		.DB	HIGH(.TASK_BOMB_RD),     HIGH(.TASK_BOMB_RU),     HIGH(.TASK_BOMB_LD),     HIGH(.TASK_BOMB_LU)
.TASK_BOMB_L:		.DB	 LOW(.TASK_BOMB_RD),      LOW(.TASK_BOMB_RU),      LOW(.TASK_BOMB_LD),      LOW(.TASK_BOMB_LU)

; {폜
.TASK_DEL_BOMB_H:	.DB	HIGH(.TASK_DEL_BOMB_RD), HIGH(.TASK_DEL_BOMB_RU), HIGH(.TASK_DEL_BOMB_LD), HIGH(.TASK_DEL_BOMB_LU)
.TASK_DEL_BOMB_L:	.DB	 LOW(.TASK_DEL_BOMB_RD),  LOW(.TASK_DEL_BOMB_RU),  LOW(.TASK_DEL_BOMB_LD),  LOW(.TASK_DEL_BOMB_LU)

; {f[^
.BOMB_DATA_RD_ANGLE:	.DB	    12,     4,    32,    12
.BOMB_DATA_RD_SPEED:	.DB	     8,    14,    14,     8
.BOMB_DATA_RD_MAX:	.DB	    50,    46,    58,    50

.BOMB_DATA_RU_ANGLE:	.DB	   -12,    -4,   -32,   -12
.BOMB_DATA_RU_SPEED:	.DB	     8,    14,    14,     8
.BOMB_DATA_RU_MAX:	.DB	   -50,   -46,   -58,   -50

.BOMB_DATA_LD_ANGLE:	.DB	128-12,128-32,128- 4,128-12
.BOMB_DATA_LD_SPEED:	.DB	     8,    14,    14,     8
.BOMB_DATA_LD_MAX:	.DB	128-50,128-46,128-58,128-50

.BOMB_DATA_LU_ANGLE:	.DB	128+12,128+32,128+ 4,128+12
.BOMB_DATA_LU_SPEED:	.DB	     8,    14,    14,     8
.BOMB_DATA_LU_MAX:	.DB	128+50,128+46,128+58,128+50

.SHOOT_HIT_ATTR:	.DB	HIT_ATTR_MISSILE
			.DB	HIT_ATTR_LASER
			.DB	HIT_ATTR_WAVE
