; ================================================================================ 
;   darius/src/regs.inc                                                            
;                                                                                  
;   Copyright (C) 2017 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

; ------------------------------------------------ 
;   PPU WX^                                   
; ------------------------------------------------ 
PPU_REG_CTRL1		=	$2000				; 䃌WX^P
PPU_CTRL1_INT		=	1<<7				; VSync 荞݋
PPU_CTRL1_SPR8		=	0<<5				; XvCgTCY 8x8
PPU_CTRL1_SPR16		=	1<<5				; XvCgTCY 8x16
PPU_CTRL1_BG0		=	0<<4				; BG LN^[e[uAhX $0000
PPU_CTRL1_BG1		=	1<<4				; BG LN^[e[uAhX $1000
PPU_CTRL1_SPR0		=	0<<3				; XvCgLN^[e[uAhX $0000
PPU_CTRL1_SPR1		=	1<<3				; XvCgLN^[e[uAhX $1000
PPU_CTRL1_ADD1		=	0<<2				; VRAM ANZX̃AhXʂP
PPU_CTRL1_ADD32		=	1<<2				; VRAM ANZX̃AhX32
PPU_CTRL1_NT0		=	0<<0				; CXN[AhX $2000
PPU_CTRL1_NT1		=	1<<0				; CXN[AhX $2400
PPU_CTRL1_NT2		=	2<<0				; CXN[AhX $2800
PPU_CTRL1_NT3		=	3<<0				; CXN[AhX $2C00

PPU_REG_CTRL2		=	$2001				; 䃌WX^Q
PPU_CTRL2_R		=	1<<7				; ԐF
PPU_CTRL2_G		=	1<<6				; ΐF
PPU_CTRL2_B		=	1<<5				; F
PPU_CTRL2_SPR		=	1<<4				; XvCg̕\
PPU_CTRL2_BG		=	1<<3				; BG ̕\
PPU_CTRL2_LSPR		=	1<<2				; ʍ[WsNZ̃XvCg\
PPU_CTRL2_LBG		=	1<<1				; ʍ[WsNZ̔wi\
PPU_CTRL2_MONO		=	1<<0				; Fݒ

PPU_REG_STATUS		=	$2002				; Xe[^XWX^
PPU_STATUS_VBLANK	=	1<<7				; XN[̕`
PPU_STATUS_SPRHIT	=	1<<6				; `XLĈOԃXvCgqbg
PPU_STATUS_SPROVR	=	1<<5				; `XLC̃XvCgѐ

PPU_REG_SPRADDR		=	$2003				; XvCgAhXWX^
PPU_REG_SPRDATA		=	$2004				; XvCgANZXWX^
PPU_REG_SCROLL		=	$2005				; XN[WX^
PPU_REG_VRAM_ADDR	=	$2006				; VRAM AhXWX^
PPU_REG_VRAM_DATA	=	$2007				; VRAM ANZXWX^


; ------------------------------------------------ 
;   PPU AhX                                   
; ------------------------------------------------ 
PPU_PAT			=	$0000				; p^[e[u
PPU_NT0			=	$2000				; ʂPl[e[u
PPU_AT0			=	$23C0				; ʂPe[u
PPU_NT1			=	$2400				; ʂQl[e[u
PPU_AT1			=	$27C0				; ʂQe[u
PPU_NT2			=	$2800				; ʂRl[e[u
PPU_AT2			=	$2BC0				; ʂRe[u
PPU_NT3			=	$2C00				; ʂSl[e[u
PPU_AT3			=	$2FC0				; ʂSe[u
PPU_BGPAL		=	$3F00				; BG pbge[u
PPU_SPRPAL		=	$3F10				; XvCgpbge[u


; ------------------------------------------------ 
;   MMC5 WX^                                  
; ------------------------------------------------ 
MMC5_PRG_MODE		=	$5100
MMC5_CHR_MODE		=	$5101
MMC5_WRAM_WP1		=	$5102
MMC5_WRAM_WP2		=	$5103
MMC5_ERAM_MODE		=	$5104
MMC5_NT_MAP		=	$5105
MMC5_PRG_8000		=	$5114
MMC5_PRG_A000		=	$5115
MMC5_PRG_C000		=	$5116
MMC5_PRG_F000		=	$5117
MMC5_SPR_BANK0		=	$5120
MMC5_SPR_BANK1		=	$5121
MMC5_SPR_BANK2		=	$5122
MMC5_SPR_BANK3		=	$5123
MMC5_SPR_BANK4		=	$5124
MMC5_SPR_BANK5		=	$5125
MMC5_SPR_BANK6		=	$5126
MMC5_SPR_BANK7		=	$5127
MMC5_BG_BANK0		=	$5128
MMC5_BG_BANK1		=	$5129
MMC5_BG_BANK2		=	$512A
MMC5_BG_BANK3		=	$512B
MMC5_CHR_BANK_H		=	$5130
MMC5_INT_LINE		=	$5203
MMC5_INT		=	$5204
MMC5_MUL_L		=	$5205
MMC5_MUL_H		=	$5206
