// ================================================================================ 
//   darius/data/darius.js                                                          
//                                                                                  
//   Copyright (C) 2017 lsluk, All rights reserved.                                 
//   http://www.geocities.jp/g_lsluk/index.html                                     
// ================================================================================ 


	var		SHOW_UNUSED=0 ;			// gpTCY 0:\, 1:\

	var		COMM_ADDRESS=0xc000 ;	// ʃf[^zuAhX
	var		BOSS_ADDRESS=0xa400 ;	// {Xf[^zuAhX
	var		COMM_COFS=0x00 ;		// ʃLN^[zuItZbg
	var		BOSS_COFS=0x81 ;		// {XLN^[zuItZbg

	var		m_objFs ;				// t@CVXeIuWFNg
	var		m_objExcel ;			// Excel IuWFNg
	var		m_objWorkbooks ;		// Workbooks IuWFNg
	var		m_aryChrBankInfo ;		// LN^[oNz
	var		m_aryColInfo ;			// J[z
	var		m_aryInfo ;				// z
	var		m_pInfo ;				// Jg
	var		m_filePath ;			// t@CpX
	var		m_dir ;					// JgfBNg
	var		m_hexType ;				// 0:AZu, 1=C


	WScript.Quit( main() ) ;


// -------------------------------------------------------------------------------- 
//   LN^[oN                                                         
//                                                                                  
//   IN : index = CfbNX                                                      
//        pCell = JnZ                                                          
//   OUT; CHRBANKINFO                                                               
// -------------------------------------------------------------------------------- 
function CHRBANKINFO(index, pCell)
{
	this.index  = index ;
	this.name   = pCell.Offset(0, 1).Text ;
	this.define = pCell.Offset(0, 2).Text ;
	this.type   = pCell.Offset(0, 3).Text ;
	this.bank   = pCell.Offset(0, 4).Value ;
	this.file   = pCell.Offset(0, 5).Text ;
}


// -------------------------------------------------------------------------------- 
//   J[                                                                     
//                                                                                  
//   IN : pCell = JnZ                                                          
//   OUT; COLINFO                                                                   
// -------------------------------------------------------------------------------- 
function COLINFO( pCell )
{
	this.col0   = parseInt(pCell.Offset(0, 0).Text, 16) ;
	this.col1   = parseInt(pCell.Offset(0, 1).Text, 16) ;
	this.col2   = parseInt(pCell.Offset(0, 2).Text, 16) ;
	this.col3   = parseInt(pCell.Offset(0, 3).Text, 16) ;
	this.define = pCell.Offset(0, 4).Text ;
}


// -------------------------------------------------------------------------------- 
//   ݒf[^                                                                     
//                                                                                  
//   IN : pCell = JnZ                                                          
//   OUT; SETUPDATA                                                                 
// -------------------------------------------------------------------------------- 
function SETUPDATA( pCell )
{
	this.chrBank0 = GetNameIndex(pCell.Offset(0, 1).Text, m_aryChrBankInfo) ;
	if( this.chrBank0 == -1 ) {
		throw new Error( "Ɏs܂(" + pCell.Row + "," + pCell.Column + ")" ) ;
	}

	this.chrBank1 = GetNameIndex(pCell.Offset(1, 1).Text, m_aryChrBankInfo) ;
	if( this.chrBank1 == -1 ) {
		throw new Error( "Ɏs܂(" + pCell.Row + "," + pCell.Column + ")" ) ;
	}

	this.chrBank2 = GetNameIndex(pCell.Offset(2, 1).Text, m_aryChrBankInfo) ;
	if( this.chrBank2 == -1 ) {
		throw new Error( "Ɏs܂(" + pCell.Row + "," + pCell.Column + ")" ) ;
	}

	this.chrBank3 = GetNameIndex(pCell.Offset(3, 1).Text, m_aryChrBankInfo) ;
	if( this.chrBank3 == -1 ) {
		throw new Error( "Ɏs܂(" + pCell.Row + "," + pCell.Column + ")" ) ;
	}

	this.sprBank = GetNameIndex(pCell.Offset(4, 1).Text, m_aryChrBankInfo) ;
	if( this.sprBank == -1 ) {
		throw new Error( "Ɏs܂(" + pCell.Row + "," + pCell.Column + ")" ) ;
	}

	this.warningMsg      = pCell.Offset( 5, 1).Text ;
	this.warningXPos     = pCell.Offset( 6, 1).Value ;
	this.bossXPos        = pCell.Offset( 7, 1).Value ;
	this.bossYPos        = pCell.Offset( 8, 1).Value ;
	this.bossAngle       = pCell.Offset( 9, 1).Value ;
	this.bossStopYPos    = pCell.Offset(10, 1).Value ;
	this.bossFadeInWait  = pCell.Offset(11, 1).Value ;
	this.bossFadeInSpeed = pCell.Offset(12, 1).Value ;
}


// -------------------------------------------------------------------------------- 
//   pbgf[^                                                                 
//                                                                                  
//   IN : pCell = JnZ                                                          
//   OUT; SETUPDATA                                                                 
// -------------------------------------------------------------------------------- 
function PALDATA( pCell )
{
	var		index ;


	pCell = pCell.Offset(0, 1) ;

	// ǃtF[hC
	this.aryFadeInWall = new Array() ;
	for(index=0; index<8; index++) {
		this.aryFadeInWall[index]    = new Array() ;
		this.aryFadeInWall[index][0] = pCell.Offset(0, index*2).Value ;
		this.aryFadeInWall[index][1] = pCell.Offset(1, index*2).Value ;
		this.aryFadeInWall[index][2] = pCell.Offset(2, index*2).Value ;
		this.aryFadeInWall[index][3] = pCell.Offset(3, index*2).Value ;
	}
	pCell = pCell.Offset(4, 0) ;

	// ǃtF[hAEg
	this.aryFadeOutWall = new Array() ;
	for(index=0; index<8*2; index++) {
		this.aryFadeOutWall[index]    = new Array() ;
		this.aryFadeOutWall[index][0] = pCell.Offset(0, index*2).Value ;
		this.aryFadeOutWall[index][1] = pCell.Offset(1, index*2).Value ;
		this.aryFadeOutWall[index][2] = pCell.Offset(2, index*2).Value ;
		this.aryFadeOutWall[index][3] = pCell.Offset(3, index*2).Value ;
	}
	pCell = pCell.Offset(4, 0) ;

	// {XtF[hC
	this.aryFadeInBoss = new Array() ;
	for(index=0; index<8; index++) {
		this.aryFadeInBoss[index]    = new Array() ;
		this.aryFadeInBoss[index][0] = pCell.Offset(0, index*2+0).Value ;
		this.aryFadeInBoss[index][1] = pCell.Offset(1, index*2+0).Value ;
		this.aryFadeInBoss[index][2] = pCell.Offset(2, index*2+0).Value ;
		this.aryFadeInBoss[index][3] = pCell.Offset(3, index*2+0).Value ;
		this.aryFadeInBoss[index][4] = pCell.Offset(0, index*2+1).Value ;
		this.aryFadeInBoss[index][5] = pCell.Offset(1, index*2+1).Value ;
		this.aryFadeInBoss[index][6] = pCell.Offset(2, index*2+1).Value ;
		this.aryFadeInBoss[index][7] = pCell.Offset(3, index*2+1).Value ;
	}
	pCell = pCell.Offset(4, 0) ;

	// {XtF[hAEg
	this.aryFadeOutBoss  = new Array() ;
	for(index=0; index<8; index++) {
		this.aryFadeOutBoss[index]    = new Array() ;
		this.aryFadeOutBoss[index][0] = pCell.Offset(0, index*2+0).Value ;
		this.aryFadeOutBoss[index][1] = pCell.Offset(1, index*2+0).Value ;
		this.aryFadeOutBoss[index][2] = pCell.Offset(2, index*2+0).Value ;
		this.aryFadeOutBoss[index][3] = pCell.Offset(3, index*2+0).Value ;
		this.aryFadeOutBoss[index][4] = pCell.Offset(0, index*2+1).Value ;
		this.aryFadeOutBoss[index][5] = pCell.Offset(1, index*2+1).Value ;
		this.aryFadeOutBoss[index][6] = pCell.Offset(2, index*2+1).Value ;
		this.aryFadeOutBoss[index][7] = pCell.Offset(3, index*2+1).Value ;
	}
}


// -------------------------------------------------------------------------------- 
//   p^[f[^                                                                 
//                                                                                  
//   IN : index = CfbNX                                                      
//        pCell = JnZ                                                          
//        cofs  = LN^[zuItZbg                                        
//   OUT; PATDATA                                                                   
// -------------------------------------------------------------------------------- 
function PATDATA(index, pCell, cofs)
{
	var		no ;


	no = pCell.Offset(0, 2).Text ;

	if( no.substr(0, 2) != "0x" ) {
		throw new Error( "p^[ԍُ(" + pCell.Row + "," + pCell.Column + ")" ) ;
	}

	this.xofs = pCell.Offset(0, 3).Value ;
	this.yofs = pCell.Offset(0, 4).Value ;
	this.no   = parseInt(no.substr(2), 16) | cofs ;
	this.attr = 0 ;

	if( pCell.Offset(0, 5).Text != "" ) {
		this.attr |= 0x40 ;
	}

	if( pCell.Offset(0, 6).Text != "" ) {
		this.attr |= 0x80 ;
	}

	if( pCell.Offset(0, 7).Text != "" ) {
		this.attr |= 0x20 ;
	}

	this.attr |= pCell.Offset(0, 8).Value ;
}


// -------------------------------------------------------------------------------- 
//   p^[                                                                   
//                                                                                  
//   IN : index  = CfbNX                                                     
//        pCell = JnZ                                                          
//   OUT: PATINFO                                                                   
// -------------------------------------------------------------------------------- 
function PATINFO(index, pCell)
{
	this.index      = index ;
	this.name       = pCell.Offset(0, 0).Text ;
	this.define     = pCell.Offset(0, 1).Text ;
	this.aryPatData = new Array() ;
}


// -------------------------------------------------------------------------------- 
//                                                                        
//                                                                                  
//   IN : index = CfbNX                                                      
//        pCell = JnZ                                                          
//   OUT: HITINFO                                                                   
// -------------------------------------------------------------------------------- 
function HITINFO(index, pCell)
{
	this.index  = index ;
	this.name   = pCell.Offset(0, 0).Text ;
	this.define = pCell.Offset(0, 1).Text ;
	this.xofs   = pCell.Offset(0, 2).Value ;
	this.yofs   = pCell.Offset(0, 3).Value ;
	this.width  = pCell.Offset(0, 4).Value ;
	this.height = pCell.Offset(0, 5).Value ;
	this.attr   = 0 ;

	if( pCell.Offset(0, 6).Text != "" ) {		// Vo[z[N
		this.attr |= 0x80 ;
	}

	if( pCell.Offset(0, 7).Text != "" ) {		// ~TC
		this.attr |= 0x40 ;
	}

	if( pCell.Offset(0, 8).Text != "" ) {		// [U[
		this.attr |= 0x20 ;
	}

	if( pCell.Offset(0, 9).Text != "" ) {		// EF[u
		this.attr |= 0x10 ;
	}

	if( pCell.Offset(0, 10).Text != "" ) {		// {
		this.attr |= 0x08 ;
	}

	if( pCell.Offset(0, 11).Text != "" ) {		// ŃGtFNg
		this.attr |= 0x01 ;
	}
}


// -------------------------------------------------------------------------------- 
//   e[uf[^                                                                 
//                                                                                  
//   IN : index = CfbNX                                                      
//        pCell = JnZ                                                          
//   OUT: TBLDATA                                                                   
// -------------------------------------------------------------------------------- 
function TBLDATA(index, pCell)
{
	var		pat, param ;


	this.index = index ;
	this.pat   = 0 ;
	this.param = 0 ;
	this.count = pCell.Offset(0, 4).Value ;

	pat = pCell.Offset(0, 2).Text ;
	if( pat != "" ) {
		if( isNaN( pat ) == false ) {		// l
			this.pat = pCell.Offset(0, 2).Value ;
		} else {							// p^[ԍ
			this.pat = GetNameIndex(pat, m_pInfo.aryPatInfo) ;
			if( this.pat == -1 ) {
				throw new Error( "Ɏs܂(" + pCell.Row + "," + pCell.Column + ")" ) ;
			}
		}
	}

	param = pCell.Offset(0, 3).Text ;
	if( param != "" ) {
		if( isNaN( param ) == false ) {		// l
			this.param = pCell.Offset(0, 3).Value ;
		} else {							// 蔻EJԂԍEoNԍ
			this.param = GetNameIndex(param, m_pInfo.aryHitInfo) ;
			if( this.param == -1 ) {
				this.param = GetNameIndex(param, m_aryChrBankInfo) ;
				if( this.param == -1 ) {
					throw new Error( "Ɏs܂(" + pCell.Row + "," + pCell.Column + ")" ) ;
				}
			}
		}
	}
}


// -------------------------------------------------------------------------------- 
//   e[u                                                                   
//                                                                                  
//   IN : index = CfbNX                                                      
//        pCell = JnZ                                                          
//   OUT: TBLINFO                                                                   
// -------------------------------------------------------------------------------- 
function TBLINFO(index, pCell)
{
	this.index      = index ;
	this.name       = pCell.Offset(0, 0).Text ;
	this.define     = pCell.Offset(0, 1).Text ;
	this.aryTblData = new Array() ;
}


// -------------------------------------------------------------------------------- 
//   BG f[^                                                              
//                                                                                  
//   IN : pCell = JnZ                                                          
//   OUT: WBGDATA                                                                   
// -------------------------------------------------------------------------------- 
function WBGDATA( pCell )
{
	var		address, value ;


	address = pCell.Offset(0, 2).Text ;
	if( address.substr(0, 2) != "0x" ) {
		throw new Error( "BGAhXُ(" + pCell.Row + "," + pCell.Column + ")" ) ;
	}

	value = pCell.Offset(0, 3).Text ;
	if( value.substr(0, 2) != "0x" ) {
		throw new Error( "BGlُ(" + pCell.Row + "," + pCell.Column + ")" ) ;
	}

	this.address = parseInt(address.substr(2), 16) ;
	this.value   = parseInt(value.substr(2),   16) ;
}


// -------------------------------------------------------------------------------- 
//   BG                                                                 
//                                                                                  
//   IN : index = CfbNX                                                      
//        pCell = JnZ                                                          
//   OUT: WBGINFO                                                                   
// -------------------------------------------------------------------------------- 
function WBGINFO(index, pCell)
{
	this.index      = index ;
	this.name       = pCell.Offset(0, 0).Text ;
	this.define     = pCell.Offset(0, 1).Text ;
	this.aryWbgData = new Array() ;
}


// -------------------------------------------------------------------------------- 
//                                                                              
//                                                                                  
//   IN : sheetName = V[g                                                      
//        fileName  = t@C                                                    
//        name      = O                                                          
//        address   = zuAhX                                                  
//   OUT: INFO                                                                      
// -------------------------------------------------------------------------------- 
function INFO(sheetName, fileName, name, address)
{
	this.sheetName       = sheetName ;
	this.fileName        = fileName ;
	this.name            = name ;
	this.address         = address ;
	this.setupData       = null ;
	this.palData         = null ;
	this.aryPatInfo      = null ;
	this.patDataCount    = 0 ;
	this.aryHitInfo      = null ;
	this.aryTblInfo      = null ;
	this.tblDataCount    = 0 ;
	this.aryWbgInfo      = new Array() ;
	this.aryPatDataXOfs  = new Array() ;
	this.aryPatDataYOfs  = new Array() ;
	this.aryPatDataNo    = new Array() ;
	this.aryPatDataAttr  = new Array() ;
	this.aryTblDataPat   = new Array() ;
	this.aryTblDataParam = new Array() ;
	this.aryTblDataCount = new Array() ;
	this.aryHitXOfs      = new Array() ;
	this.aryHitYOfs      = new Array() ;
	this.aryHitWidth     = new Array() ;
	this.aryHitHeight    = new Array() ;
	this.aryHitAttr      = new Array() ;
}


// -------------------------------------------------------------------------------- 
//   f[^                                                                     
//                                                                                  
//   IN : name    = O                                                            
//        aryData = f[^z                                                      
//        size    = f[^TCY                                                    
//   OUT: DATAINFO                                                                  
// -------------------------------------------------------------------------------- 
function DATAINFO(name, aryData, size)
{
	this.pDataInfo = null ;
	this.name      = name ;
	this.size      = size ;
	this.aryData   = aryData ;
}


// -------------------------------------------------------------------------------- 
//   y[W                                                                     
//                                                                                  
//   IN : address = AhX                                                        
//        size    = TCY                                                          
//   OUT: PAGEINFO                                                                  
// -------------------------------------------------------------------------------- 
function PAGEINFO(address, size)
{
	this.address   = address ;
	this.size      = size ;
	this.pDataInfo = null ;
}


// -------------------------------------------------------------------------------- 
//   ltH[}bg                                                               
//                                                                                  
//   IN : format =                                                              
//        value  = l                                                               
//        radix  =                                                              
//   OUT:                                                                     
// -------------------------------------------------------------------------------- 
function intFormat(format, value, radix)
{
	var		string ;


	if( radix == 16 ) {
		string = value.toString(16) ;
		if( !m_hexType ) {
			string = string.toUpperCase() ;
		}
	} else {
		string = value.toString(radix) ;
	}

	return format.slice(0, -string.length) + string ;
}


// -------------------------------------------------------------------------------- 
//   ^utH[}bg                                                               
//                                                                                  
//   IN : format =                                                              
//        string =                                                            
//   OUT:                                                                     
// -------------------------------------------------------------------------------- 
function tab4Format(string, count)
{
	return string + "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t".slice(0, count-(string.length-(string.length&3))/4 ) ;
}

function tab8Format(string, count)
{
	return string + "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t".slice(0, count-(string.length-(string.length&7))/8 ) ;
}


// -------------------------------------------------------------------------------- 
//   Op^[ԍ擾                                                     
//                                                                                  
//   IN : name = O                                                               
//   OUT: -1  != p^[ԍ                                                       
//        -1  == Ȃ                                                               
// -------------------------------------------------------------------------------- 
function GetPatNo( name )
{
	var		pAryPatInfo ;
	var		index, count ;


	pAryPatInfo = m_pInfo.aryPatInfo ;
	count       = pAryPatInfo.length ;

	for(index=0; index<count; index++) {
		if( pAryPatInfo[index].name == name ) {
			return pAryPatInfo[index].index ;
		}
	}

	return -1 ;
}


// -------------------------------------------------------------------------------- 
//   O疼Oz̃CfbNX擾                                           
//                                                                                  
//   IN : name     = O                                                           
//        pAryName = Oz                                                       
//   OUT: -1      != CfbNX                                                   
//        -1      == Ȃ                                                           
// -------------------------------------------------------------------------------- 
function GetNameIndex(name, pAryName)
{
	var		index ;


	for(index=0; index<pAryName.length; index++) {
		if( pAryName[index].name == name ) {
			return pAryName[index].index ;
		}
	}

	return -1 ;
}


// -------------------------------------------------------------------------------- 
//   p^[쐬                                                             
//                                                                                  
//   IN : pCell = JnZ                                                          
//        cofs  = LN^[zuItZbg                                        
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function createPatInfo(pCell, cofs)
{
	var		pAryPatInfo, pPatInfo ;


	m_pInfo.aryPatInfo = new Array() ;
	pAryPatInfo        = m_pInfo.aryPatInfo ;

	while( 1 ) {
		pPatInfo                        = new PATINFO(m_pInfo.patDataCount, pCell) ;
		pPatInfo.aryPatData[0]          = new PATDATA(m_pInfo.patDataCount++, pCell, cofs) ;
		pAryPatInfo[pAryPatInfo.length] = pPatInfo ;
		pCell                           = pCell.Offset(1, 0) ;

		while( pCell.Offset(0, 1).Text == "" ) {
			if( pCell.Offset(0, 2).Text == "" ) {
				pPatInfo.aryPatData[pPatInfo.aryPatData.length-1].attr |= 0x04 ;
				return ;
			}
			pPatInfo.aryPatData[pPatInfo.aryPatData.length] = new PATDATA(m_pInfo.patDataCount++, pCell, cofs) ;
			pCell                                           = pCell.Offset(1, 0) ;
		}
		pPatInfo.aryPatData[pPatInfo.aryPatData.length-1].attr |= 0x04 ;
	}
}


// -------------------------------------------------------------------------------- 
//   쐬                                                               
//                                                                                  
//   IN : pCell = JnZ                                                          
//   OUT: HITINFO z                                                              
// -------------------------------------------------------------------------------- 
function createHitInfo( pCell )
{
	var		pAryHitInfo, pHitInfo ;
	var		index ;


	m_pInfo.aryHitInfo = new Array() ;
	pAryHitInfo        = m_pInfo.aryHitInfo ;
	index              = 0 ;

	while( pCell.Offset(0, 1).Text != "" ) {
		pAryHitInfo[pAryHitInfo.length] = new HITINFO(index, pCell) ;
		pCell                           = pCell.Offset(1, 0) ;
		index++ ;
	}
}


// -------------------------------------------------------------------------------- 
//   e[u쐬                                                             
//                                                                                  
//   IN : pCell = JnZ                                                          
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function createTblInfo( pCell )
{
	var		pAryTblInfo, pTblInfo ;


	m_pInfo.aryTblInfo = new Array() ;
	pAryTblInfo        = m_pInfo.aryTblInfo ;

	while( 1 ) {
		pTblInfo                        = new TBLINFO(m_pInfo.tblDataCount, pCell) ;
		pTblInfo.aryTblData[0]          = new TBLDATA(m_pInfo.tblDataCount++, pCell) ;
		pAryTblInfo[pAryTblInfo.length] = pTblInfo ;
		pCell                           = pCell.Offset(1, 0) ;

		while( pCell.Offset(0, 1).Text == "" ) {
			if( pCell.Offset(0, 4).Text == "" ) {
				return ;
			}
			pTblInfo.aryTblData[pTblInfo.aryTblData.length] = new TBLDATA(m_pInfo.tblDataCount++, pCell) ;
			pCell                                           = pCell.Offset(1, 0) ;
		}
	}
}


// -------------------------------------------------------------------------------- 
//   BG 쐬                                                          
//                                                                                  
//   IN : pCell = JnZ                                                          
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function createWbgInfo( pCell )
{
	var		pAryWbgInfo, pWbgInfo ;
	var		count ;


	m_pInfo.aryWbgInfo = new Array() ;
	pAryWbgInfo        = m_pInfo.aryWbgInfo ;
	count              = 0 ;

	while( 1 ) {
		pWbgInfo                        = new WBGINFO(count, pCell) ;
		pWbgInfo.aryWbgData[0]          = new WBGDATA( pCell ) ;
		pAryWbgInfo[pAryWbgInfo.length] = pWbgInfo ;
		pCell                           = pCell.Offset(1, 0) ;
		count++ ;

		while( pCell.Offset(0, 1).Text == "" ) {
			if( pCell.Offset(0, 2).Text == "" ) {
				return ;
			}
			pWbgInfo.aryWbgData[pWbgInfo.aryWbgData.length] = new WBGDATA( pCell ) ;
			pCell                                           = pCell.Offset(1, 0) ;
			count++ ;
		}
	}
}


// -------------------------------------------------------------------------------- 
//   oN쐬                                                               
//                                                                                  
//   IN : objWorksheet = [NV[gIuWFNg                                   
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function createBankInfo( objWorksheet )
{
	var		pCell ;


	m_aryChrBankInfo = new Array() ;
	pCell            = objWorksheet.Cells(3, 1) ;

	while( pCell.Offset(0, 1).Text != "" ) {
		m_aryChrBankInfo[m_aryChrBankInfo.length] = new CHRBANKINFO(m_aryChrBankInfo.length, pCell) ;
		pCell                                     = pCell.Offset(1, 0) ;
	}
}


// -------------------------------------------------------------------------------- 
//   J[쐬                                                               
//                                                                                  
//   IN : objWorksheet = [NV[gIuWFNg                                   
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function createColInfo( objWorksheet )
{
	var		pCell ;


	m_aryColInfo = new Array() ;
	pCell        = objWorksheet.Cells(2, 2) ;

	while( pCell.Offset(0, 0).Text != "" ) {
		m_aryColInfo[m_aryColInfo.length] = new COLINFO( pCell ) ;
		pCell                             = pCell.Offset(1, 0) ;
	}
}


// -------------------------------------------------------------------------------- 
//   쐬                                                                     
//                                                                                  
//   IN : sheetName = V[gI                                                    
//        fileName  = t@C                                                    
//        name      = O                                                          
//        address   = zuAhX                                                  
//        row       = s                                                            
//        setup     = ݒ                                                        
//        pal       = pbg                                                    
//        tbl       = e[u`                                                
//        pat       = p^[`                                                
//        hit       = `                                                  
//        wbg       = BG `i-1 ͖j                              
//        cofs      = LN^[zuItZbg                                    
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function createInfo(sheetName, fileName, name, address, row, setup, pal, tbl, pat, hit, wbg, cofs)
{
	var		objWorksheet, pAryPatInfo ;
	var		pPatData, pTblData ;
	var		index, count, length, pCell ;

	// V[g
	objWorksheet = m_objWorkbooks.WorkSheets( sheetName )

	// 쐬
	m_pInfo                     = new INFO(sheetName, fileName, name, address) ;
	m_aryInfo[m_aryInfo.length] = m_pInfo ;

	// ݒ擾
	if( setup != -1 ) {
		m_pInfo.setupData = new SETUPDATA( objWorksheet.Cells(row, setup) ) ;
	}

	// pbg
	if( pal != -1 ) {
		m_pInfo.palData = new PALDATA( objWorksheet.Cells(row, pal) ) ;
	}

	// p^[`
	createPatInfo(objWorksheet.Cells(row, pat), cofs) ;
	createHitInfo( objWorksheet.Cells(row, hit) ) ;
	createTblInfo( objWorksheet.Cells(row, tbl) ) ;

	if( wbg != -1 ) {
		createWbgInfo( objWorksheet.Cells(row, wbg) ) ;
	}

	// p^[f[^擾
	length = 0 ;
	for(index=0; index<m_pInfo.aryPatInfo.length; index++) {
		pPatData = m_pInfo.aryPatInfo[index].aryPatData ;
		for(count=0; count<pPatData.length; count++,length++) {
			m_pInfo.aryPatDataXOfs[length] = pPatData[count].xofs ;
			m_pInfo.aryPatDataYOfs[length] = pPatData[count].yofs ;
			m_pInfo.aryPatDataNo[length]   = pPatData[count].no ;
			m_pInfo.aryPatDataAttr[length] = pPatData[count].attr ;
		}
	}

	// e[uf[^擾
	length = 0 ;
	for(index=0; index<m_pInfo.aryTblInfo.length; index++) {
		pTblData = m_pInfo.aryTblInfo[index].aryTblData ;
		for(count=0; count<pTblData.length; count++,length++) {
			m_pInfo.aryTblDataPat[length]   = pTblData[count].pat ;
			m_pInfo.aryTblDataParam[length] = pTblData[count].param ;
			m_pInfo.aryTblDataCount[length] = pTblData[count].count ;
		}
	}

	// f[^擾
	for(index=0; index<m_pInfo.aryHitInfo.length; index++) {
		m_pInfo.aryHitXOfs[m_pInfo.aryHitXOfs.length]     = m_pInfo.aryHitInfo[index].xofs ;
		m_pInfo.aryHitYOfs[m_pInfo.aryHitYOfs.length]     = m_pInfo.aryHitInfo[index].yofs ;
		m_pInfo.aryHitWidth[m_pInfo.aryHitWidth.length]   = m_pInfo.aryHitInfo[index].width ;
		m_pInfo.aryHitHeight[m_pInfo.aryHitHeight.length] = m_pInfo.aryHitInfo[index].height ;
		m_pInfo.aryHitAttr[m_pInfo.aryHitAttr.length]     = m_pInfo.aryHitInfo[index].attr ;
	}
}


// -------------------------------------------------------------------------------- 
//   y[Wփf[^}                                                   
//                                                                                  
//   IN : aryPageInfo = y[Wz                                              
//        pDataInfo   = f[^                                                  
//        size        = TCY                                                      
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function insertDataInfo(aryPageInfo, pDataInfo, size)
{
	var		pPrev ;
	var		index ;


	for(index=0; index<aryPageInfo.length; index++) {
		if( size > aryPageInfo[index].size ) {
			continue ;
		}

		aryPageInfo[index].size -= size ;

		// ŌɎt
		pPrev = aryPageInfo[index] ;
		while( pPrev.pDataInfo != null ) {
			pPrev = pPrev.pDataInfo ;
		}
		pPrev.pDataInfo = pDataInfo ;
		break ;
	}
}


// -------------------------------------------------------------------------------- 
//   [e                                                         
//                                                                                  
//   IN : file    = t@C̃nh                                              
//        aryData = f[^                                                          
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function writeFileDumpASM(file, aryData)
{
	var		index ;


	for(index=0; index<aryData.length; index++) {
		if( !(index&15) ) {
			file.Write( "\r\n	.DB	" + intFormat( "$00", aryData[index]&0xff, 16) ) ;
		} else {
			file.Write(                 intFormat(",$00", aryData[index]&0xff, 16) ) ;
		}
	}
	if( aryData.length & 15 ) {
		file.WriteLine("") ;
	}
}


// -------------------------------------------------------------------------------- 
//   BG ݃e[u                                                
//                                                                                  
//   IN : file       = t@C̃nh                                           
//        aryWbgInfo = BG                                               
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function writeWbgTable(file, aryWbgInfo)
{
	var		index ;


	file.WriteLine("") ;

	for(index=0; index<aryWbgInfo.length; index++) {
		file.WriteLine( "	.DW	" + aryWbgInfo[index].define + "_PROC" ) ;
	}
}


// -------------------------------------------------------------------------------- 
//   AZupCN[ht@C쐬                                     
//                                                                                  
//   IN : pInfo =                                                               
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function writeFileIncludeAsm( pInfo )
{
	var		file, pCell ;
	var		index ;


	pCell = m_objWorkbooks.WorkSheets( "oN" ).Cells(3, 3) ;

	file = m_objFs.OpenTextFile(m_dir + "bank.inc", 2, true, -2) ;

	file.WriteLine("") ;

	for(index=0; index<256; index++) {
		if( pCell.Offset(index, 0).Text == "" ) {
			continue ;
		}

		file.WriteLine(tab8Format(pCell.Offset(index, 0).Text, 4) + "=	" + index) ;
	}

	file.Close() ;
}


// -------------------------------------------------------------------------------- 
//   AZup\[Xt@C쐬                                           
//                                                                                  
//   IN : pInfo =                                                               
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function writeFileSourceAsm( pInfo )
{
	var		aryDataInfo, aryPageInfo ;
	var		pSetupData, pPalData, pPatData, pTblData, pWbgInfo, pWbgData, pDataInfo ;
	var		file, index, count, value, comment, address ;


	file = m_objFs.OpenTextFile(m_dir + pInfo.fileName + ".asm", 2, true, -2) ;

	file.WriteLine("") ;

	// p^[
	for(index=0; index<pInfo.aryPatInfo.length; index++) {
		file.WriteLine(tab8Format(pInfo.aryPatInfo[index].define, 4) + "=	" + pInfo.aryPatInfo[index].index) ;
	}
	file.WriteLine("") ;

	// 蔻
	for(index=0; index<pInfo.aryHitInfo.length; index++) {
		file.WriteLine(tab8Format(pInfo.aryHitInfo[index].define, 4) + "=	" + pInfo.aryHitInfo[index].index) ;
	}
	file.WriteLine("") ;

	// e[u
	for(index=0; index<pInfo.aryTblInfo.length; index++) {
		file.WriteLine(tab8Format(pInfo.aryTblInfo[index].define, 4) + "=	" + pInfo.aryTblInfo[index].index) ;
	}

	// BG 
	if( pInfo.aryWbgInfo.length ) {
		file.WriteLine("") ;

		for(index=0; index<pInfo.aryWbgInfo.length; index++) {
			file.WriteLine(tab8Format(pInfo.aryWbgInfo[index].define, 4) + "=	" + index) ;
		}
	}

	// f[^쐬
	aryDataInfo     = new Array() ;
	aryDataInfo[0]  = new DATAINFO("PAT_XOFS",   pInfo.aryPatDataXOfs,  pInfo.aryPatDataXOfs.length) ;
	aryDataInfo[1]  = new DATAINFO("PAT_YOFS",   pInfo.aryPatDataYOfs,  pInfo.aryPatDataYOfs.length) ;
	aryDataInfo[2]  = new DATAINFO("PAT_NO",     pInfo.aryPatDataNo,    pInfo.aryPatDataNo.length) ;
	aryDataInfo[3]  = new DATAINFO("PAT_ATTR",   pInfo.aryPatDataAttr,  pInfo.aryPatDataAttr.length) ;
	aryDataInfo[4]  = new DATAINFO("TBL_PAT",    pInfo.aryTblDataPat,   pInfo.aryTblDataPat.length) ;
	aryDataInfo[5]  = new DATAINFO("TBL_PARAM",  pInfo.aryTblDataParam, pInfo.aryTblDataParam.length) ;
	aryDataInfo[6]  = new DATAINFO("TBL_COUNT",  pInfo.aryTblDataCount, pInfo.aryTblDataCount.length) ;
	aryDataInfo[7]  = new DATAINFO("HIT_XOFS",   pInfo.aryHitXOfs,      pInfo.aryHitXOfs.length) ;
	aryDataInfo[8]  = new DATAINFO("HIT_YOFS",   pInfo.aryHitYOfs,      pInfo.aryHitYOfs.length) ;
	aryDataInfo[9]  = new DATAINFO("HIT_WIDTH",  pInfo.aryHitWidth,     pInfo.aryHitWidth.length) ;
	aryDataInfo[10] = new DATAINFO("HIT_HEIGHT", pInfo.aryHitHeight,    pInfo.aryHitHeight.length) ;
	aryDataInfo[11] = new DATAINFO("HIT_ATTR",   pInfo.aryHitAttr,      pInfo.aryHitAttr.length) ;

	if( pInfo.aryWbgInfo.length ) {
		aryDataInfo[12] = new DATAINFO("WBG", null, pInfo.aryWbgInfo.length*2) ;
	}

	// y[W쐬
	aryPageInfo = new Array( 13 ) ;
	address     = pInfo.address ;
	for(index=0; index<aryPageInfo.length; index++,address+=256) {
		aryPageInfo[index] = new PAGEINFO(address, 256) ;
	}

	if( !pInfo.aryWbgInfo.length ) {

		for(index=0; index<aryDataInfo.length; index++) {
			insertDataInfo(aryPageInfo, aryDataInfo[index], aryDataInfo[index].size) ;
		}

		// gpTCY\
		if( SHOW_UNUSED ) {
			WScript.Echo( pInfo.name + ":" ) ;
		}

		// f[^
		for(index=0; index<aryDataInfo.length; index++) {
			if( aryPageInfo[index].size == 256 ) {
				break ;
			}

			// gpTCY\
			if( SHOW_UNUSED ) {
				if( aryPageInfo[index].size ) {
					WScript.Echo( "    " + intFormat("$0000", aryPageInfo[index].address&0xffff, 16) + "=" + aryPageInfo[index].size ) ;
				}
			}

			file.WriteLine("\r\n") ;
			file.WriteLine("	.ORG	" + intFormat("$0000", aryPageInfo[index].address&0xffff, 16)) ;

			pDataInfo = aryPageInfo[index].pDataInfo ;
			do {
				file.Write( pInfo.name + "_" + pDataInfo.name + ":" ) ;

				if( pDataInfo.aryData != null ) {
					writeFileDumpASM(file, pDataInfo.aryData) ;
				} else {
					writeWbgTable(file, pInfo.aryWbgInfo) ;
				}
				pDataInfo = pDataInfo.pDataInfo ;
			} while( pDataInfo != null ) ;
		}

		// J[f[^
		file.WriteLine("\r\n") ;
		file.Write("COL_DATA0:	.DB	" + intFormat("$00", m_aryColInfo[0].col0, 16)) ;
		for(index=1; index<m_aryColInfo.length; index++) {
			file.Write( intFormat(",$00", m_aryColInfo[index].col0, 16)) ;
		}
		file.Write("\r\n") ;

		file.Write("COL_DATA1:	.DB	" + intFormat("$00", m_aryColInfo[0].col1, 16)) ;
		for(index=1; index<m_aryColInfo.length; index++) {
			file.Write( intFormat(",$00", m_aryColInfo[index].col1, 16)) ;
		}
		file.Write("\r\n") ;

		file.Write("COL_DATA2:	.DB	" + intFormat("$00", m_aryColInfo[0].col2, 16)) ;
		for(index=1; index<m_aryColInfo.length; index++) {
			file.Write( intFormat(",$00", m_aryColInfo[index].col2, 16)) ;
		}
		file.Write("\r\n") ;

		file.Write("COL_DATA3:	.DB	" + intFormat("$00", m_aryColInfo[0].col3, 16)) ;
		for(index=1; index<m_aryColInfo.length; index++) {
			file.Write( intFormat(",$00", m_aryColInfo[index].col3, 16)) ;
		}
		file.Write("\r\n") ;

	} else {

		file.WriteLine("\r\n") ;
		file.WriteLine("	.ORG	" + intFormat("$0000", BOSS_ADDRESS, 16)) ;

		// pbg
		pPalData = pInfo.palData ;

		file.WriteLine( pInfo.name + "_FADEIN_WALL:" ) ;
		for(index=0; index<8; index++) {
			file.WriteLine( "	.DB	" + intFormat( "   ", pPalData.aryFadeInWall[index][0]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeInWall[index][1]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeInWall[index][2]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeInWall[index][3]&0xff, 10)) ;
		}
		file.WriteLine("") ;

		file.WriteLine( pInfo.name + "_FADEOUT_WALL:" ) ;
		for(index=0; index<8; index++) {
			file.WriteLine( "	.DB	" + intFormat( "   ", pPalData.aryFadeOutWall[index][0]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeOutWall[index][1]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeOutWall[index][2]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeOutWall[index][3]&0xff, 10)) ;
		}
		file.WriteLine("") ;

		file.WriteLine( pInfo.name + "_FADEIN_BOSS2:" ) ;
		for(index=0; index<8; index++) {
			file.WriteLine( "	.DB	" + intFormat( "   ", pPalData.aryFadeInBoss[index][0]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeInBoss[index][1]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeInBoss[index][2]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeInBoss[index][3]&0xff, 10)) ;
		}
		file.WriteLine("") ;

		file.WriteLine( pInfo.name + "_FADEIN_BOSS3:" ) ;
		for(index=0; index<8; index++) {
			file.WriteLine( "	.DB	" + intFormat( "   ", pPalData.aryFadeInBoss[index][4]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeInBoss[index][5]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeInBoss[index][6]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeInBoss[index][7]&0xff, 10)) ;
		}
		file.WriteLine("") ;

		file.WriteLine( pInfo.name + "_FADEOUT_BOSS2:" ) ;
		for(index=0; index<8; index++) {
			file.WriteLine( "	.DB	" + intFormat( "   ", pPalData.aryFadeOutBoss[index][0]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeOutBoss[index][1]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeOutBoss[index][2]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeOutBoss[index][3]&0xff, 10)) ;
		}
		file.WriteLine("") ;

		file.WriteLine( pInfo.name + "_FADEOUT_BOSS3:" ) ;
		for(index=0; index<8; index++) {
			file.WriteLine( "	.DB	" + intFormat( "   ", pPalData.aryFadeOutBoss[index][4]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeOutBoss[index][5]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeOutBoss[index][6]&0xff, 10) + "," +
			                            intFormat( "   ", pPalData.aryFadeOutBoss[index][7]&0xff, 10)) ;
		}
		file.WriteLine("") ;

		// ݒ
		pSetupData = pInfo.setupData ;
		file.WriteLine(pInfo.name + "_INI_CHRBANK0:") ;
		file.WriteLine("	.DB	" + pSetupData.chrBank0 + "\r\n") ;

		file.WriteLine(pInfo.name + "_INI_CHRBANK1:") ;
		file.WriteLine("	.DB	" + pSetupData.chrBank1 + "\r\n") ;

		file.WriteLine(pInfo.name + "_INI_CHRBANK2:") ;
		file.WriteLine("	.DB	" + pSetupData.chrBank2 + "\r\n") ;

		file.WriteLine(pInfo.name + "_INI_CHRBANK3:") ;
		file.WriteLine("	.DB	" + pSetupData.chrBank3 + "\r\n") ;

		file.WriteLine(pInfo.name + "_INI_SPRBANK:") ;
		file.WriteLine("	.DB	" + pSetupData.sprBank + "\r\n") ;

		file.WriteLine(pInfo.name + "_WARNING_MSG:") ;
		file.Write("	.DB	" + intFormat("$00", ((0x2220+pSetupData.warningXPos)/256)&0xff, 16) + ","  +
		                        intFormat("$00",  (0x2220+pSetupData.warningXPos)     &0xff, 16) + ", " +
		                        (pSetupData.warningMsg.length+2)) ;
		count = pSetupData.warningMsg.length ;
		for(index=0; index<count; index++) {
			value = pSetupData.warningMsg.charCodeAt(index) ;
			if( value == 0x20 ) {
				file.Write( ",$00" ) ;
			} else {
				file.Write( intFormat(",$00", value&0xff, 16) ) ;
			}
		}
		file.Write( ",$10,$80" ) ;

		for(index+=2; index<15; index++) {
			file.Write( ",$00" ) ;
		}
		file.WriteLine("\r\n") ;

		file.WriteLine(pInfo.name + "_INI_XPOS:") ;
		file.WriteLine("	.DW	" + pSetupData.bossXPos + "\r\n") ;

		file.WriteLine(pInfo.name + "_INI_YPOS:") ;
		file.WriteLine("	.DW	" + pSetupData.bossYPos + "\r\n") ;

		file.WriteLine(pInfo.name + "_INI_ANGLE:") ;
		file.WriteLine("	.DB	" + pSetupData.bossAngle + "\r\n") ;

		file.WriteLine(pInfo.name + "_INI_STOP_YPOS:") ;
		file.WriteLine("	.DB	" + pSetupData.bossStopYPos + "\r\n") ;

		file.WriteLine(pInfo.name + "_INI_FADEIN_WAIT:") ;
		file.WriteLine("	.DW	" + pSetupData.bossFadeInWait + "\r\n") ;

		file.WriteLine(pInfo.name + "_INI_FADEIN_SPEED:") ;
		file.WriteLine("	.DB	" + pSetupData.bossFadeInSpeed + "\r\n") ;

		file.WriteLine(pInfo.name + "_INI_PROC:") ;
		file.WriteLine("	.DW	" + pInfo.name + "_INI") ;

		file.WriteLine(pInfo.name + "_INI_START_PROC:") ;
		file.WriteLine("	.DW	" + pInfo.name + "_START") ;

		for(index=0; index<4; index++) {
			file.WriteLine("\r\n") ;
			file.WriteLine("	.ORG	" + intFormat("$0000", (BOSS_ADDRESS+0x0100+(index*0x0100))&0xffff, 16)) ;
			file.Write( pInfo.name + "_" + aryDataInfo[index].name + ":" ) ;
			writeFileDumpASM(file, aryDataInfo[index].aryData) ;
		}

		for(; index<7; index++) {
			file.WriteLine("\r\n") ;
			file.WriteLine("	.ORG	" + intFormat("$0000", (BOSS_ADDRESS+0x0500+((index-4)*0x0080))&0xffff, 16)) ;
			file.Write( pInfo.name + "_" + aryDataInfo[index].name + ":" ) ;
			writeFileDumpASM(file, aryDataInfo[index].aryData) ;
		}

		for(; index<12; index++) {
			file.WriteLine("\r\n") ;
			file.WriteLine("	.ORG	" + intFormat("$0000", (BOSS_ADDRESS+0x0680+((index-7)*0x0040))&0xffff, 16)) ;
			file.Write( pInfo.name + "_" + aryDataInfo[index].name + ":" ) ;
			writeFileDumpASM(file, aryDataInfo[index].aryData) ;
		}

	}

	if( pInfo.aryWbgInfo != null ) {

		file.WriteLine("") ;

		// BG f[^
		for(index=0; index<pInfo.aryWbgInfo.length; index++) {
			pWbgInfo = pInfo.aryWbgInfo[index] ;
			file.WriteLine("") ;
			file.WriteLine( pWbgInfo.define + "_PROC:" ) ;
			file.WriteLine( "	MOV	MMC5_ERAM_MODE, #2" ) ;

			value = -1000 ;

			for(count=0; count<pWbgInfo.aryWbgData.length; count++) {
				pWbgData = pWbgInfo.aryWbgData[count] ;
				if( value != pWbgData.value ) {
					if( (value+1) == pWbgData.value ) {
						file.WriteLine("	INX") ;
					} else
					if( (value-1) == pWbgData.value ) {
						file.WriteLine("	DEX") ;
					} else {
						file.WriteLine("	LDX	" + intFormat("#$00",           pWbgData.value   &0xff,   16) ) ;
						value = pWbgData.value ;
					}
					value = pWbgData.value ;
				}

				file.WriteLine("	STX	" + intFormat("$0000", (0x5c00+pWbgData.address)&0xffff, 16) ) ;
			}
			file.WriteLine( "	MOV	MMC5_ERAM_MODE, #0" ) ;
			file.WriteLine("	VRAM_PROC_RET") ;
		}
	}

	file.Close() ;
}


// -------------------------------------------------------------------------------- 
//   AZupt@C쐬                                                 
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function createFileASM()
{
	m_hexType = 0 ;

	writeFileIncludeAsm() ;

	for(index=0; index<m_aryInfo.length; index++) {
		writeFileSourceAsm( m_aryInfo[index] ) ;
	}
}


// -------------------------------------------------------------------------------- 
//   C pt@C쐬                                                         
//                                                                                  
//   IN : file  = t@Cnh                                                  
//        pInfo =                                                               
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function writeFileC(file, pInfo)
{
	var		pPatData, pHitInfo, pTblData, pWbgData ;
	var		index, count, comment ;

	// p^[`ItZbg
	file.Write("static const UINT8					" + pInfo.name + "_PAT_XOFS[]={") ;

	for(index=0; index<pInfo.aryPatDataXOfs.length; index++) {
		if( !(index&15) ) {
			file.Write("\r\n										") ;
		}
		file.Write(intFormat("0x00", pInfo.aryPatDataXOfs[index]&0xff, 16) + ",") ;
	}

	file.WriteLine("\r\n									} ;") ;
	file.WriteLine("") ;

	// p^[`ItZbg
	file.Write("static const UINT8					" + pInfo.name + "_PAT_YOFS[]={") ;

	for(index=0; index<pInfo.aryPatDataYOfs.length; index++) {
		if( !(index&15) ) {
			file.Write("\r\n										") ;
		}
		file.Write(intFormat("0x00", pInfo.aryPatDataYOfs[index]&0xff, 16) + ",") ;
	}

	file.WriteLine("\r\n									} ;") ;
	file.WriteLine("") ;

	// p^[`p^[ԍ
	file.Write("static const UINT8					" + pInfo.name + "_PAT_NO[]={") ;

	for(index=0; index<pInfo.aryPatDataNo.length; index++) {
		if( !(index&15) ) {
			file.Write("\r\n										") ;
		}
		file.Write(intFormat("0x00", pInfo.aryPatDataNo[index]&0xff, 16) + ",") ;
	}

	file.WriteLine("\r\n									} ;") ;
	file.WriteLine("") ;

	// p^[`
	file.Write("static const UINT8					" + pInfo.name + "_PAT_ATTR[]={") ;

	for(index=0; index<pInfo.aryPatDataAttr.length; index++) {
		if( !(index&15) ) {
			file.Write("\r\n										") ;
		}
		file.Write(intFormat("0x00", pInfo.aryPatDataAttr[index]&0xff, 16) + ",") ;
	}

	file.WriteLine("\r\n									} ;") ;
	file.WriteLine("") ;


	// e[u`p^[ԍ
	file.Write("static const UINT8					" + pInfo.name + "_TBL_PAT[]={") ;

	for(index=0; index<pInfo.aryTblDataPat.length; index++) {
		if( !(index&15) ) {
			file.Write("\r\n										") ;
		}
		file.Write(intFormat("0x00", pInfo.aryTblDataPat[index]&0xff, 16) + ",") ;
	}

	file.WriteLine("\r\n									} ;") ;
	file.WriteLine("") ;

	// e[u`p[^
	file.Write("static const UINT8					" + pInfo.name + "_TBL_PARAM[]={") ;

	for(index=0; index<pInfo.aryTblDataParam.length; index++) {
		if( !(index&15) ) {
			file.Write("\r\n										") ;
		}
		file.Write(intFormat("0x00", pInfo.aryTblDataParam[index]&0xff, 16) + ",") ;
	}

	file.WriteLine("\r\n									} ;") ;
	file.WriteLine("") ;

	// e[u`t[
	file.Write("static const UINT8					" + pInfo.name + "_TBL_COUNT[]={") ;

	for(index=0; index<pInfo.aryTblDataCount.length; index++) {
		if( !(index&15) ) {
			file.Write("\r\n										") ;
		}
		file.Write(intFormat("0x00", pInfo.aryTblDataCount[index]&0xff, 16) + ",") ;
	}

	file.WriteLine("\r\n									} ;") ;
	file.WriteLine("") ;

	// f[^
	file.Write("static const UINT8					" + pInfo.name + "_HIT_DATA[]={") ;

	for(index=0; index<pInfo.aryHitData.length; index++) {
		if( !(index&15) ) {
			file.Write("\r\n										") ;
		}
		file.Write(intFormat("0x00", pInfo.aryHitData[index]&0xff, 16) + ",") ;
	}

	file.WriteLine("\r\n									} ;") ;
	file.WriteLine("") ;
}


// -------------------------------------------------------------------------------- 
//   C pt@C쐬                                                         
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function createFileC()
{
	var		pPatData ;
	var		file, index, count ;


	m_hexType = 1 ;

	// wb_[t@C
	file = m_objFs.OpenTextFile(m_dir + "data.h", 2, true, -2) ;

	file.WriteLine("	enum {") ;

	for(index=0; index<m_aryInfo.length; index++) {
		if( index ) {
			file.WriteLine("") ;
		}
		file.WriteLine("		" + "// " + m_aryInfo[index].sheetName) ;

		// p^[
		for(count=0; count<m_aryInfo[index].aryPatInfo.length; count++) {
			file.WriteLine("		" + tab4Format(m_aryInfo[index].aryPatInfo[count].define, 6) + "=	" + m_aryInfo[index].aryPatInfo[count].index + ",") ;
		}
		file.WriteLine("") ;

		// 蔻
		for(count=0; count<m_aryInfo[index].aryHitInfo.length; count++) {
			file.WriteLine("		" + tab4Format(m_aryInfo[index].aryHitInfo[count].define, 6) + "=	" + m_aryInfo[index].aryHitInfo[count].index + ",") ;
		}
		file.WriteLine("") ;

		// e[u
		for(count=0; count<m_aryInfo[index].aryTblInfo.length; count++) {
			file.WriteLine("		" + tab4Format(m_aryInfo[index].aryTblInfo[count].define, 6) + "=	" + m_aryInfo[index].aryTblInfo[count].index + ",") ;
		}

		// BG 
		if( m_aryInfo[index].aryWbgInfo != null ) {
			file.WriteLine("") ;

			for(count=0; count<m_aryInfo[index].aryWbgInfo.length; count++) {
				file.WriteLine("		" + tab4Format(m_aryInfo[index].aryWbgInfo[count].define, 6) + "=	" + m_aryInfo[index].aryWbgInfo[count].index + ",") ;
			}
		}
	}

	file.WriteLine("	} ;") ;
	file.WriteLine("") ;
	file.Close() ;

	// \[Xt@C
	file = m_objFs.OpenTextFile(m_dir + "data.c", 2, true, -2) ;

	for(index=0; index<m_aryInfo.length; index++) {
		writeFileC(file, m_aryInfo[index]) ;
	}

	file.Close() ;
}


// -------------------------------------------------------------------------------- 
//   C                                                                     
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: Ȃ                                                                      
// -------------------------------------------------------------------------------- 
function main()
{
	if( !WScript.Arguments.length ) {
		return 1 ;
	}

	try {
		m_objFs    = new ActiveXObject( "Scripting.FileSystemObject" ) ;
		m_filePath = m_objFs.GetAbsolutePathName( WScript.Arguments(0) ) ;
		m_dir      = m_objFs.GetParentFolderName( m_filePath ) ;
		if( m_dir.charAt( m_dir.length - 1 ) != '\\' ) {
			m_dir += "\\" ;
		}

		m_objExcel         = new ActiveXObject( "Excel.Application" ) ;
		m_objExcel.Visible = true ;
		m_objWorkbooks     = m_objExcel.Workbooks.Open( m_filePath ) ;
		m_aryInfo          = new Array() ;

		createBankInfo( m_objWorkbooks.WorkSheets( "oN" ) ) ;
		createColInfo( m_objWorkbooks.WorkSheets( "J[e[u" ) ) ;
		createInfo("",         "comm_data",  "COMM",  COMM_ADDRESS, 3, -1, -1,  1,  7, 17, -1, COMM_COFS) ;
		createInfo("King Fossil",  "boss0_data", "BOSS0", BOSS_ADDRESS, 3,  1,  4, 22, 28, 39, 52, BOSS_COFS) ;
		createInfo("Electric Fan", "boss1_data", "BOSS1", BOSS_ADDRESS, 3,  1,  4, 22, 28, 39, 52, BOSS_COFS) ;
		createInfo("Guard Savage", "boss2_data", "BOSS2", BOSS_ADDRESS, 3,  1,  4, 22, 28, 39, 52, BOSS_COFS) ;

		// t@C
		if( WScript.Arguments.length == 1 ) {
			createFileASM()
		} else {
			createFileC() ;
		}

		WScript.Echo( "I" ) ;
	}
	catch( e ) {
		WScript.Echo( "" + e.name + " : " + e.message ) ;
	}

	m_objExcel.Quit() ;

	m_objExcel = null ;
	m_objFs    = null ;

	return 0 ;
}
