; ================================================================================ 
;   darius/src/work.asm                                                            
;                                                                                  
;   Copyright (C) 2017 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.ZP

TEMP			.DS	8				; e|
VSYNC_FLAG:		.DS	1				; VSync tO
TICK_COUNT		.DS	1				; eBbNJE^
IRQ_ENABLE		.DS	1				; 荞ݗL
IRQ_LINE:		.DS	1				; 荞ݔs
SYS_STATUS		.DS	1				; VXe
SYS_PROC:							; VXe
SYS_PROC_L:		.DS	1
SYS_PROC_H:		.DS	1
PRE_PROC:							; O
PRE_PROC_L:		.DS	1
PRE_PROC_H:		.DS	1
POST_PROC:							; ㏈1
POST_PROC_L:		.DS	1
POST_PROC_H:		.DS	1
ISR_IRQ:		.DS	1				; IRQ 荞݃T[rX[`
ISR_IRQ_PROC_L:		.DS	1
ISR_IRQ_PROC_H:		.DS	1
VRAM_DATA_COUNT:	.DS	1				; VRAM ]f[^
VRAM_PROC_COUNT:	.DS	1				; VRAM 
BOSS_BANK0:		.DS	1				; {XwioNO
BOSS_BANK1:		.DS	1				; {XwioNP
BOSS_BANK2:		.DS	1				; {XwioNQ
BOSS_BANK3:		.DS	1				; {XwioNR
BG_BANK0:		.DS	1				; wioNO
BG_BANK1:		.DS	1				; wioNP
BG_BANK2:		.DS	1				; wioNQ
BG_BANK3:		.DS	1				; wioNR
SPR_BANK0:		.DS	1				; XvCgoNO
SPR_BANK1:		.DS	1				; XvCgoNP
PAD_NORM:		.DS	1				; pbhԒʏ
PAD_OLD:		.DS	1				; pbhԑO
PAD_ONCE:		.DS	1				; pbhԂPx̂
TASK_RUN		.DS	1				; s^XNԍ
TASK_QUE_R:		.DS	1				; s^XNL[ǂݍ݈ʒu
TASK_QUE_W:		.DS	1				; s^XNL[݈ʒu
TASK_QUE_E:		.DS	1				; s^XNL[Iʒu
TASK_COUNT		.DS	1				; c^XN
SPR_BUFF_H:		.DS	1				; XvCgobt@擪ʒu
SPR_BUFF_W:		.DS	1				; XvCgobt@݈ʒu
SPR_EXT_ATTR:		.DS	1				; XvCgg
HIT_PLAYER:		.DS	1				; v[[tO
HIT_BULLET_COUNT:	.DS	1				; e^XN
HIT_BULLET_QUE:		.DS	13				; e^XNL[
WALL_TOP:		.DS	1				; Ǐ㕔ʒu
WALL_BOTTOM:		.DS	1				; ǉʒu
SETUP_STAGE:		.DS	1				; Xe[Wԍ
SETUP_PLAYER_COUNT:	.DS	1				; v[[
SETUP_SHOOT_LEVEL:	.DS	1				; Vbgx
SETUP_BOMB_LEVEL:	.DS	1				; {x
SETUP_ARM_LEVEL:	.DS	1				; A[x
STAGE:			.DS	1				; Xe[Wԍ
PLAYER_COUNT:		.DS	1				; v[[
SHOOT_LEVEL:		.DS	1				; Vbgx
SHOOT_TBL:		.DS	1				; Vbge[u
SHOOT_PAT:		.DS	1				; Vbgp^[
SHOOT_HIT_Y:		.DS	1				; VbgItZbg
SHOOT_HIT_H:		.DS	1				; Vbg
SHOOT_SPEED:		.DS	1				; Vbgx
SHOOT_SPEED_F:		.DS	1				; Vbgx̌Œ菬
SHOOT_PROC_H:		.DS	2				; Vbg^XN
SHOOT_PROC_L:		.DS	2				; Vbg^XN
BOMB_LEVEL:		.DS	1				; {x
CRE_BOMB_PROC:		.DS	2				; {^XN쐬
ARM_LEVEL:		.DS	1				; A[x
ARM_PAL:		.DS	1				; A[pbg
ARM_COUNT:		.DS	1				; A[
UPDATE_SCORE:		.DS	1				; _XVtO
SCORE:			.DS	7				; _
SHOOT_COUNT:		.DS	1				; Vbg
BOMB_RD_COUNT:		.DS	1				; E{
BOMB_RU_COUNT:		.DS	1				; E{
BOMB_LD_COUNT:		.DS	1				; {
BOMB_LU_COUNT:		.DS	1				; {
SHOOT_TASK_NO:		.DS	5				; Vbg^XNԍ
BOMB_RD_TASK_NO:	.DS	2				; E{^XNԍ
BOMB_RU_TASK_NO:	.DS	2				; E{^XNԍ
BOMB_LD_TASK_NO:	.DS	2				; {^XNԍ
BOMB_LU_TASK_NO:	.DS	2				; {^XNԍ




	.BSS
	.ORG	$0100

TASK_NO:		.DS	TASK_MAX - TASK_RESERVED_MAX	; ^XNԍ
VRAM_DATA_BUFF:		.DS	64				; VRAM ]f[^obt@
VRAM_PROC_BUFF_H:	.DS	8				; VRAM 쏈obt@
VRAM_PROC_BUFF_L:	.DS	8				; VRAM 쏈obt@

STACK:			.DS	STACK_SIZE			; X^bN


	.ORG	$0200

SPR_BUFF:		.DS	256				; XvCgobt@
TASK_QUE:		.DS	256				; s^XNL[
HIT_QUE:
HIT_QUE0:		.DS	TASK_MAX			; ^XNL[O
HIT_QUE1:		.DS	TASK_MAX			; ^XNL[P
HIT_QUE2:		.DS	TASK_MAX			; ^XNL[Q
HIT_QUE3:		.DS	TASK_MAX			; ^XNL[R


	.ORG	$6000

TCB_PROC_H:		.DS	TASK_MAX			; ^XN
TCB_PROC_L:		.DS	TASK_MAX			; ^XN
TCB_ACT:		.DS	TASK_MAX			; ANVԍ
TCB_PAT:		.DS	TASK_MAX			; p^[ԍ
TCB_PAT_COUNT:		.DS	TASK_MAX			; p^[JE^
TCB_ANGLE:		.DS	TASK_MAX			; px
TCB_SPEED:		.DS	TASK_MAX			; x
TCB_COUNT0:		.DS	TASK_MAX			; ėpJE^O
TCB_COUNT1:		.DS	TASK_MAX			; ėpJE^P
TCB_COUNT2:		.DS	TASK_MAX			; ėpJE^Q
TCB_COUNT3:		.DS	TASK_MAX			; ėpJE^R
TCB_WORK0:
TCB_XPOS_H:		.DS	TASK_MAX			; W
TCB_WORK1:
TCB_XPOS_L:		.DS	TASK_MAX			; W
TCB_WORK2:
TCB_XPOS_F:		.DS	TASK_MAX			; WŒ菬
TCB_WORK3:
TCB_YPOS_H:		.DS	TASK_MAX			; W
TCB_WORK4:
TCB_YPOS_L:		.DS	TASK_MAX			; W
TCB_WORK5:
TCB_YPOS_F:		.DS	TASK_MAX			; WŒ菬
TCB_PARAM:		.DS	TASK_MAX			; p[^
TCB_HIT:		.DS	TASK_MAX			; 
TCB_HIT_TYPE:		.DS	TASK_MAX			; 蔻
TCB_HIT_X:		.DS	TASK_MAX			; 蔻JnW
TCB_HIT_Y:		.DS	TASK_MAX			; 蔻JnW
TCB_HIT_W:		.DS	TASK_MAX			; 蔻蕝
TCB_HIT_H:		.DS	TASK_MAX			; 蔻荂
TCB_HIT_ATTR:		.DS	TASK_MAX			; 蔻葮
